
\section{Klassifikationsschema f"ur Standortprobleme}
Im folgenden f"uhren wir ein Klassifikationsschema f"ur Standortprobleme \index{Standortproblem!Klassifikationsschema} ein, das
dabei helfen soll, einen "Uberblick "uber die Vielfalt der Probleme zu bekommen.
Wir orientieren uns bei dieser Klassifizierung an entsprechenden Bezeichnungsweisen 
aus der Schedulingtheorie, die sich ja in der Vergangenheit sehr bew"ahrt haben.

Das Schema besteht aus f"unf Positionen und hat somit die Form
$$\mbox{Pos 1 / Pos 2 / Pos 3 / Pos 4 / Pos 5,}$$
wobei die einzelnen Positionen die folgende Bedeutung haben.
\begin{description}
\item[Pos 1:] Anzahl der neuen Anlagen
\item[Pos 2:] Art des Standortproblems. Beispiele f"ur Eintr"age sind
 \begin{description}
 \item[P] {\bf planare} Standortprobleme\index{Standortproblem!planares}, d.h. existierende und neue Standorte sind durch ihre 
  Koordinaten in der Ebene gegeben,
 \item[D] {\bf diskrete} Standortprobleme\index{Standortproblem!diskretes}, d.h. es stehen nur endlich viele Pl"atze f"ur die neuen
  Standorte zur Verf"ugung oder
 \item[N] {\bf Netzwerk}--Standortprobleme\index{Standortproblem!Netzwerk--}, d.h. existierende und neue Standorte sind 
  Teile eines Netzwerks.
 \end{description}
\item[Pos 3:] Besonderheiten des Standortproblems. Beispiele f"ur Eintr"age sind
 \begin{description}
 \item[R] Restriktionen f"ur die Wahl von neuen Standorten
 \item[$v_m=1$] Festlegung der Gewichte, mit denen die Einzelentfernungen multipliziert werden.
 \end{description}
\item[Pos 4:] Legt die Defintion der Einzelentfernung fest. Beispiele f"ur Eintr"age sind
 \begin{description}
 \item[$l_2$] Euklidische Entfernung
 \item[$l_{metr}$] Entfernung, die der Definition einer beliebigen Metrik gen"ugt
 \item[$l_{Netz}$] k"urzeste Entfernung in einem Netzwerk
 \end{description}
\item[Pos 5:] Definiert die Zielfunktion als Funktion der Einzelentfernungen. Beispiele f"ur Eintr"age sind
 \begin{description}
 \item[$\sum_{}^{}$] gewichtete Summe der Einzelfunktionen ({\em Medianprobleme})
 \item[$\max_{}$] Maximum der Einzelentfernungen ({\em Centerprobleme})
 \end{description}
\end{description}

Sind in einer Position keine Angaben zu machen, so kennzeichnet man dies durch einen 
Punkt. So bedeutet z.B. ein Punkt in der Position 3, da"s keine Besonderheit vorliegt,
w"ahrend ein Punkt in Position 5 anzeigt, da"s eine beliebige Zielfunktion betrachtet werden kann.
