#! /usr/local/bin/perl5 -w

require 5.001; # I actually don't know if it works with Perl 4, but I sure don't support it

$maxfilenamelen = 20;
@found = `find . -name *.cc -o -name *.cpp -print -exec grep -n lola_error {} \\\;`;
while($#found > -1) {
    $_ = shift @found; chomp;
    if (/^(\.[^ ]*)/) { $file = $1; next;}
    if (/^(\d+):/) {
	$linenum = $1;
	if (/lola_error\s*\(\x22([^\x22]*)\x22,(\d+),(\d+)\)/) {
	    $code = $2; $message = $1; $exitcode = $3;
	    if ($maxfilenamelen < length($file)) { $maxfilenamelen = length($file); }
	    if (exists $msg{$code}) { 
		push @{$msg{$code}},  [$file,$linenum,$message,$exitcode];
	    } else {
		$msg{$code} = [[$file,$linenum,$message,$exitcode]];
	    }
	} else {
	    print STDERR "Malformed lola_error in line: $_\n";
	}
	next;
    }
    print STDERR "Couldn't interpret: $_\n";
}

printf("%4s | %".$maxfilenamelen."s | %4s | %4s | %s\n","code","file","line","exit","message");
printf("--------------------------------------------------------------------\n");
foreach (sort keys %msg) {
    for $ref (@{$msg{$_}}) {
	printf("%4s | %".$maxfilenamelen."s | %4d | %4d | %s\n",$_,$ref->[0],$ref->[1],$ref->[3],$ref->[2]);
    }
}
