#include "lolagraph.h"
#include <stdio.h>
#include <LOLA/tkscript.h>
#include <string.h>
#include <malloc.h>

int _CG (ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
/********************************************************************
* Purpose   : Calls the C++ - Routine in lolagraph.cpp from GraphEd
* Returns   :
* Influences: %
* Date      : 11-26-95
* Author    : Holger Hennes
*********************************************************************/
{
	_CreateGauge();
	return 0;
}

int _CH (ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
/********************************************************************
* Purpose   : Calls the C++ - Routine in lolagraph.cpp from GraphEd
* Returns   :
* Influences: %
* Date      : 09-26-95
* Author    : Lothar Schnell
*********************************************************************/
{
	_ConvHull();
	return 0;
}

void _lolag(int argc, char **argv)
/********************************************************************
* Purpose   : Evaluates the TK-Script "grapheditor" and creates Command
*             ConvHull
* Returns   :
* Influences: %
* Date      : 09-26-95
* Author    : Lothar Schnell
*********************************************************************/
{
	Tk_Window mainWindow;
	Tcl_Interp *interp; 
	static char *display = NULL;

	interp = Tcl_CreateInterp();
	Tcl_CreateCommand (interp, "ConvHull", _CH, (ClientData) NULL,(Tcl_CmdDeleteProc *) NULL);

	interp = Tcl_CreateInterp();
	Tcl_CreateCommand (interp, "CreateGauge", _CG, (ClientData) NULL,(Tcl_CmdDeleteProc *) NULL);

/********************************************************************
* TK-Version <=4.0; TCL-Version <=7.4
********************************************************************/
#if (TK_MAJOR_VERSION <= 4 && TK_MINOR_VERSION <= 0) 

	mainWindow = Tk_CreateMainWindow(interp, display, argv[0], "Tk");
	if (mainWindow == NULL) {
		fprintf(stderr, "%s\n", interp->result);
		exit(1);
	}

	if (Tcl_Init(interp) == TCL_ERROR) {
		fprintf(stderr, "Tcl_Init failed: %s\n", interp->result);
	}
	if (Tk_Init(interp) == TCL_ERROR) {
		fprintf(stderr, "Tk_Init failed: %s\n", interp->result);
	}
#else
/********************************************************************
* TK-Version 4.2; TCL-Version 7.6
********************************************************************/

        if (Tcl_Init(interp) == TCL_ERROR) {
                fprintf(stderr, "Tcl_Init failed: %s\n", interp->result);
        }
        if (Tk_Init(interp) == TCL_ERROR) {
                fprintf(stderr, "Tk_Init failed: %s\n", interp->result);
        }

        mainWindow = Tk_MainWindow(interp);
        if (mainWindow == NULL) {
                fprintf(stderr, "%s\n", interp->result);
                exit(1);
        }
#endif
/********************************************************************/
	{
	  char *path, search, *backslash;
	  FILE *script;
	  
	  path = (char *) malloc((strlen(argv[0])+50)*sizeof(char));
	  strcpy(path, argv[0]);
	  /* zunaechts relativ zu diesem File suchen */
#ifdef UNIX
	  search='/';
	  backslash=strrchr(path,search);
	  path[strlen(path)-strlen(backslash)+1]=0;
	  path=strcat(path,"../tk/grapheditor");
#else
	  search='\\';
	  backslash=strrchr(path,search);
	  path[strlen(path)-strlen(backslash)+1]=0;
	  path=strcat(path,"..\\tk\\grapheditor");
#endif
	  if((script = fopen(path,"r"))==0){
	    /* installationspfad nehmen */
	    if ((script = fopen(TKGRAPH,"r"))==0) {
	      fputs("Cannot find Tcl-script grapheditor.\n",stderr);
	    } else {
	      fclose(script);
	      Tcl_EvalFile(interp,TKGRAPH);
	      Tk_MainLoop();
	    }
	  } else {
	    fclose(script);
	    Tcl_EvalFile(interp,path);
	    Tk_MainLoop();
	  }
	  free(path);
	}
}
