#include "lolagraph.h"
#include <stdio.h>
#include <iostream.h>
#include <LEDA/stream.h>
#include <LEDA/string.h>
#include <LEDA/list.h>
#include <LEDA/point.h>
#include <LEDA/plane.h>
#include <LEDA/plane_alg.h>
#include <LOLA/gauge_util.h>


void _CreateGauge()
/********************************************************************
* Purpose   : Calls the lolaroutine to create a poly gauge
* Returns   : 
* Influences: %
* Date      : Nov 98
* Author    : Holger Hennes
*********************************************************************/
{
	CreatePolyGauge();
	return;
}

void _ConvHull () 
/********************************************************************
* Purpose   : Compute the Convex_Hull in GraphEd for convex polyhedron
* Returns   : 
* Influences: %
* Date      : Sep 95
* Author    : Lothar Schnell
*********************************************************************/
{
	long act_pos;
	string tmp=" ";
	list_item pointer_to_point;
	point p;
	list<point> Lpoly;

 #ifdef UNIX
	ifstream file ("/tmp/convpolyin",ios::in);
 #else
	string temp = string(getenv("tmp"));
	temp += string("/convpolyin"); 
	ifstream file (temp,ios::in);
 #endif
	act_pos = file.tellg();
	Lpoly.clear();
	while (tmp != "end")
	{
		file.seekg (act_pos);
		file >> p;
		Lpoly.append(p);
		act_pos = file.tellg();
		file >> tmp;
	}
	if (Lpoly.length() >= 3)
	{
		list<point> C = CONVEX_HULL(Lpoly);
   #ifdef UNIX
		ofstream file ("/tmp/convpolyout",ios::out);
   #else
		string temp = getenv("tmp");
		temp += string("/convpolyout"); 
		ofstream file (temp,ios::out);
   #endif
		for(pointer_to_point=C.first(); pointer_to_point; pointer_to_point=C.succ(pointer_to_point))
		{
			p=C.contents(pointer_to_point);
			tmp = string ("%8.3lf %8.3lf ",p.xcoord(),p.ycoord()); 
			file << tmp << endl;
		}  
		file << "end" ;
	}  
}

int main(int argc, char **argv)
/********************************************************************
* Purpose   : MAIN - Calls lolag that evaluate the TK-Scripts
* Returns   : 
* Influences: %
* Date      : Sep 95
* Author    : Lothar Schnell
*********************************************************************/
{

#ifdef  WITHTCLTK
	_lolag(argc,argv);
#else
	cerr << "No Tcl/Tk-support - please reconfigure using lolaconfig." << endl;
#endif
	return 0;
}
