#include "lola.h"
#include <stdlib.h>
#ifdef UNIX
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#endif
#include <malloc.h>
#include <stdio.h>
#include <LOLA/tkscript.h>
#include <string.h>


int _Random (ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
/********************************************************************
* Purpose   : Creates a random integer
* Returns   : integer
* Influences: %
* Date      : 06-04-96
* Author    : Lothar Schnell
*********************************************************************/
{
  char s[5];
  int ran,minran,maxran,diffran;
  minran=atoi(argv[1]);
  maxran=atoi(argv[2]);
  diffran=maxran-minran;
  diffran = RAND_MAX/diffran;
  if (argc != 3) {
    interp->result = "wrong # args";
    return TCL_ERROR;
  } else {
    ran=minran+rand()/diffran;
  }
  sprintf(s,"%d",ran);
  Tcl_SetVar (interp, "ranint", s ,0);
  return 0;
}



int _RestrInt (ClientData clientData, Tcl_Interp *interp, int argc, char *argv[]) 
/********************************************************************
* Purpose   : Calls Int_all_Restr with extrafile and Set inters in lolafront
* Returns   :
* Influences: %
* Date      : 02-12-96
* Author    : Lothar Schnell
*********************************************************************/
{
  int Restrint=0;
  Tcl_SetVar (interp, "inters", "0",0);
  if (argc > 2) {
    interp->result = "wrong # args";
    return TCL_ERROR;
  } else {
    Restrint=_Int_all_Restr(argv[1]); 
  }
  if (Restrint == 1) Tcl_SetVar (interp, "inters", "1",0);
  return 0;
}


void _lolatk(int argc, char **argv)
/********************************************************************
* Purpose   : Evaluates the TK-Script "lolafront" and creates Command
*             LocAlgo and GraphEd
* Returns   :
* Influences: %
* Date      : 09-26-95
* Author    : Lothar Schnell
*********************************************************************/
{
	Tk_Window mainWindow;
	Tcl_Interp *interp;
	static char *display = NULL;


	interp = Tcl_CreateInterp();
	Tcl_CreateCommand (interp, "RestrInt", _RestrInt, (ClientData) NULL,
			   (Tcl_CmdDeleteProc *) NULL);


	Tcl_CreateCommand (interp, "random", _Random, (ClientData) NULL,
			   (Tcl_CmdDeleteProc *) NULL);


/********************************************************************
* TK-Version <=4.0; TCL-Version <=7.4
********************************************************************/
#if (TK_MAJOR_VERSION <= 4 && TK_MINOR_VERSION <= 0) 
	mainWindow = Tk_CreateMainWindow(interp, display, argv[0], "Tk");
	if (mainWindow == NULL) {
		fprintf(stderr, "%s\n", interp->result);
		exit(1);
	}

	if (Tcl_Init(interp) == TCL_ERROR) {
		fprintf(stderr, "Tcl_Init failed: %s\n", interp->result);
	}
	if (Tk_Init(interp) == TCL_ERROR) {
		fprintf(stderr, "Tk_Init failed: %s\n", interp->result);
	}

#else
/********************************************************************
* TK-Version 4.1; TCL-Version 7.5
********************************************************************/
	if (Tcl_Init(interp) == TCL_ERROR) {
		fprintf(stderr, "Tcl_Init failed: %s\n", interp->result);
	}
	if (Tk_Init(interp) == TCL_ERROR) {
		fprintf(stderr, "Tk_Init failed: %s\n", interp->result);
	}

	mainWindow = Tk_MainWindow(interp);
	if (mainWindow == NULL) {
		fprintf(stderr, "%s\n", interp->result);
		exit(1);
	}
#endif
/********************************************************************/
	{
	  char *path, search, *backslash;
	  FILE *script;
	  
	  path = (char *) malloc((strlen(argv[0])+50)*sizeof(char));
	  strcpy(path, argv[0]);
	  /* zunaechts relativ zu diesem File suchen */
#ifdef UNIX
	  search='/';
	  backslash=strrchr(path,search);
	  path[strlen(path)-strlen(backslash)+1]=0;
	  path=strcat(path,"../tk/lolafront");
#else
	  search='\\';
	  backslash=strrchr(path,search);
	  path[strlen(path)-strlen(backslash)+1]=0;
	  path=strcat(path,"..\\tk\\lolafront");
#endif
	  if((script = fopen(path,"r")) == 0) {
	    /* installationspfad nehmen */
	    if ((script = fopen(TKLOLA,"r")) == 0) {
	      fputs("Cannot find Tcl-script lolafront.\n",stderr);
	    } else {
	      fclose(script);
	      Tcl_EvalFile(interp,TKLOLA);
	      Tk_MainLoop();
	    }
	  } else {
	    fclose(script);
	    Tcl_EvalFile(interp,path);
	    Tk_MainLoop();
	  }
	  free(path);
	}
}
