// --
// Declaration of class barrier 
// --

#ifndef _BASE_BARRIER_H
#define _BASE_BARRIER_H

#include <LOLA/restriction.h>

/*{\Manpage {barrier} {} {Algorithms for Barriers}}*/

class barrier:virtual public list<restriction*> {
/*{\Mdefinition An instance of the data type $barriers$ consists of the algorithm to solve 
	planar location problems with barriers.}*/
protected:
   list<location> solution;

/*{\Mcreation B }*/
/*{\Mtext {\it barrier} B; \hspace{1cm}
creates a variable $B$ of type $barrier$.}*/
/*{\Moperations 2.3 4.7 }*/
public:
   list<location> alg_solution() {return solution;}
	
  int type() { return t_barrier; }
  
     double l2_sum(facilities& EX,bool erase,int choose=1,double percent=0.1,double accel=1.0,double init_ss=0.01,double epsilon=0.001);
/*{\Mopl computes the optimum for problem class $1/P/(R,\infty)/l_2/\sum$
and returns the objective value.}*/

};
#endif
