#ifndef LOLA_BLOCKNORM_H
#define LOLA_BLOCKNORM_H

#include <LOLA/facilities.h>

class Blocknorm {
 private:
   double *angles;
   int angles_size;
   location *points;
   
 public:
	/* only half points with y >= 0 & x bel. && y > 0 for x < 0 */
   Blocknorm(int dim = 0);
   Blocknorm(double dim, double point1x, double point1y,...);
	Blocknorm(list<point> &pnts);   /* pnts must be all points, but uses half */
	Blocknorm(list<location> &locs);/* locs must be all points, but uses half */
   Blocknorm(const Blocknorm &B);
   ~Blocknorm() { delete[] angles; delete[] points; }

   int size() { return angles_size; }
   
   double& operator () (int idx) { return angles[idx]; }
   location& operator [] (int idx) { return points[idx]; }
   bool operator == (Blocknorm &B);
   bool operator != (Blocknorm &B);
   Blocknorm& operator = (const Blocknorm &B); 
   
friend ostream& operator << (ostream &out, Blocknorm &B);
};

#endif
