#ifndef _GLOBALS_h_
#define _GLOBALS_h_
#include <LEDA/point.h>

// ------------- some constants ------------------

#define L_INF 1.0E50         // infimum
#define L_inf -1             // inf-norm
#define L_max -1             // max-norm
#define L_eps 1E-14          // epsilon-bound

const point origin(0,0);    // defines the origin

// ------------- some functions ------------------

#define L_sqr(x) ((x)*(x))

#define L_MAX(a,b) ((a<b) ? b:a) 
#define L_MIN(a,b) ((a<b) ? a:b) 

inline int L_fak(int n) {
   int tmp = 1;
   if (n > 0)
     for (int i = n; i>0 ; i--) tmp = tmp * i; 
   return tmp;
}


inline double L_signum(double x) {
 if (x<0) return -1;
 else return 1;
}

inline int L_bin_coeff(int n, int k) {
   if (k <= n)
     return L_fak(n) / (L_fak(k)*L_fak(n-k));
   return 1;
}
#endif
