#ifndef GRAPH_RESTRICTION_H
#define GRAPH_RESTRICTION_H
//#include <LOLA/lolaundirected.h>
#include <LOLA/loladirected.h>
#include <LOLA/lolatree.h>
//#include <LOLA/graph_util.h>
/*{\Manpage {graph_restriction} {} {Restricted Graph Problems}}*/

class graph_restriction : public list<edge_segment>
/*{\Mdefinition An instance of the data type $graph\_restriction$ consists of a 
 list with restrictions on edges. This list is derived from the Leda-list
list$<edge\_segment>$, where the listitems are of the lola-type 
$edge\_segment$.}*/
{
 protected:

 public:
/*{\Mcreation EL }*/
/*{\Mtext {\it graph\_restriction} EL; \hspace{1cm}
creates an empty list of restrictions $EL$}*/
/*{\Moperations 5.0 3.7 }*/


//lolagraph create_restrG(lolagraph& G, list<int>& del_list);

/*{\Mopl
creates the lolagraph with respect to the list of restrictions and gives a
reference to a list of indices of nodes inside the restriction. }*/

//void ReadGRestr(ifstream& file);

/*{\Mopl
reads a restricion file for a lolagraph and returns the list of forbidden edge pieces. }*/

//list<sol_typ> median(double& objval,lolagraph& G);

/*{\Mopl
returns the solution of the local restrictive 1-median of a graph.}*/

//list<sol_typ> abs_median(double& objval,lolaundirected& U);

/*{\Mopl
returns the solution of the absolute restrictive 1-median of a graph.}*/


};

#endif


