#ifndef LOLA_ERROR_HANDLER_H
#define LOLA_ERROR_HANDLER_H

/*#include <stdlib.h>
#include <iostream.h>
#include <LEDA/basic.h>*/
#include <LEDA/panel.h>

class LOLA_ERROR {
private:
  static int count;

public:
  // the output routines combine LOLA_ERROR::windowed by logical AND with
  // their argument windowed
  static bool windowed;

  LOLA_ERROR();

  ~LOLA_ERROR();
};

static LOLA_ERROR _LOLA_ERROR;

void lola_error(const char* errormessage,int errorcode,int exitcode,
		bool windowed=true);
/*{\Mop If windowed, opens a window containing the errormessage, otherwise
prints it to cerr. Exits with return code exitcode.}*/

void lola_message(const char* message, int exitcode, bool windowed=true);
/*{\Mop If windowed, opens a window containing the message, otherwise
prints it to cerr. Exits with return code exitcode iff exitcode is not zero.}*/

void lola_message(const char* message, int exitcode, int okcode, bool windowed=true);
/*{\Mop If windowed, opens a window containing the message, otherwise
prints it to cerr. Exits if okcode is zero, otherwise continues the started function.}*/

inline void lola_error(const string errormessage,int errorcode,int exitcode,
		       bool windowed=true) { 
  lola_error(errormessage.cstring(),errorcode,exitcode,windowed);
}

inline void lola_message(const string message, int exitcode, 
			 bool windowed=true) {
  lola_message(message.cstring(),exitcode,windowed);
}

#endif
