/***************************************************************************
* class loladirected for LOLA (Library of Location Algorithms)
* Purpose:
* Author : Karen Schulze
* Date   : May-1997
***************************************************************************/

#ifndef _LOLADIRECTED_H_
#define _LOLADIRECTED_H_

#include <LOLA/classlolagraph.h>
/*{\Manpage {loladirected} {} {Directed Graphs}}*/

class loladirected: public lolagraph {

/*{\Mdefinition An instance of the data type $loladirected$ is a directed 
graph derived of the data type $lolagraph$.}*/

public:
loladirected (lolagraph& G);

/*{\Mcreation GD }*/
/*{\Mtext {\it loladirected GD}; \hspace{1cm}
creates a directed lolagraph $GD$.}*/

/*{\Moperations 3.3 4.9 }*/

list<sol_typ> inmedian(double& objval);

/*{\Mop
returns the solution of the 1-inmedian problem of the
 nodes for a directed graph.}*/


list<sol_typ> outmedian(double& objval);

/*{\Mopl
returns the solution of the 1-outmedian problem of the
 nodes for a directed graph.}*/


};
#endif
