/***************************************************************************
* class lolatree for LOLA (Library of Location Algorithms)
* Purpose:
* Author : Karen Schulze
* Date   : May-1997
***************************************************************************/

#ifndef _LOLATREE_H_
#define _LOLATREE_H_

#include <LOLA/lolaundirected.h>

/*{\Manpage {lolatree} {} {Trees}}*/

//class lolatree: public lolaundirected
class lolatree: public lolaundirected
{
public:
lolatree (lolaundirected G);

//Konstruktor um ein graph_util-Objekt einem lolatree-Objekt zuzuweisen...

//operator lolagraph () {make_undirected(); if (!is_tree()) lola_error("Graph is not a tree ",1701,1); 

/*{\Mdefinition An instance of the data type $lolatree$ is a special undirected
$lolagraph$, containing no loops. It is derived from the data type $lolaundirected$.}*/

/*{\Mcreation T }*/
/*{\Mtext {\it lolatree T}; \hspace{1cm}
creates a lolatree $T$.}*/

/*{\Moperations 3.3 3.9 }*/
/*{\Mtext
\medskip
{\bf 3.1 Helpfunctions}
\medskip }*/

bool is_tree();

/*{\Mop
tests if G is a tree, i.e. containing no loops.}*/

/*{\Mtext
\medskip
{\bf 3.2 Algorithms}
\medskip }*/

list<sol_typ> tree_node_med(double& objval);

/*{\Mopl
returns the solution of the local 1-median problem on a tree.}*/

list<sol_typ> tree_med(double& objval); 

/*{\Mopl
returns the solution of the absolute 1-median problem on a tree.}*/

list<sol_typ> tree_center(double& objval);

/*{\Mopl
returns the solution of the absolute 1-center problem on a tree.}*/

list<sol_typ> two_tree_center(double& objval);

/*{\Mopl
returns the solution of the absolute 2-center problem on a tree.}*/

void splitting(node w, node v, GRAPH<node_weight,double> TREE); 

list<sol_typ> tree_node_center(double& objval);

/*{\Mopl
returns the solution of the local 1-center problem on a tree.}*/

};
#endif
