/***************************************************************************
* class lolaundirected for LOLA (Library of Location Algorithms)
* Purpose:
* Author : Karen Schulze
* Date   : May-1997
***************************************************************************/

#ifndef _LOLAUNDIRECTED_H_
#define _LOLAUNDIRECTED_H_

#include <LOLA/classlolagraph.h>
/*{\Manpage {lolaundirected} {} {Undirected Graphs}}*/
class lolaundirected: public lolagraph

/*{\Mdefinition An instance of the data type $lolaundirected$ is a undirected 
graph derived of the data type $lolagraph$. 
}*/

{
protected:

public:

//Konstruktor um ein lolagraph-Objekt einem lolaundirected-Objekt zuzuweisen...
//lolaundirected (lolagraph& G);
lolaundirected (lolagraph G);

/*{\Mcreation GU }*/
/*{\Mtext {\it lolaundirected GU}; \hspace{1cm}
creates a undirected lolagraph $GU$.}*/

/*{\Moperations 3.3 4.9 }*/

// Algorithmen speziell fuer ungerichtete Graphen:

list<sol_typ> abs_med(double& objval);

/*{\Mop
returns the solution of the 1-median problem of a whole graph.}*/

list<sol_typ> edge_append(list<sol_typ> L,matrix M,double& objval);

/* Karens Diplomarbeit: */
// parloc.cpp
list<edge_segment> bi_medpareto(list<vector>& objval);
list<edge_segment> Q_medpareto(list<vector>& objval);
list<edge_segment> edge_pareto(matrix& D,matrix& F,int i, int j, double length, list<bottle_elem>& bottlenecks);
};
#endif


