#ifndef _ELLIPSE_H_
#define _ELLIPSE_H_

#include <LOLA/restriction.h>

class restr_ell:virtual public restriction {
 protected:
   point f1, f2, intsecpnt;
   segment a, b;
   double phi, excentricity;
   const int typ = restr_e;
   bool ioflag;
   double _bartyp;
   
 public:
   restr_ell();
   restr_ell(point F1, point F2, segment A, segment B);
   restr_ell(point intersection_A_B, segment A, segment B);
   restr_ell(location F1, location F2, segment A, segment B);
   restr_ell(const restr_ell &E);
   ~restr_ell();
   
   restr_ell& operator = (const restr_ell &E);

   int type() { return typ; }
   void in_forbid() { ioflag = true; }
   void out_forbid() { ioflag = false; }
   bool inout() { return ioflag; }
   double bar_typ() { return _bartyp; }
   list<point> focus();
   list<line> axis();
   
   bool inside(const point &P);
   bool inside(const location &Loc);
   bool inside(const segment &s);
   list<point> intersect(point &p, point &q);
   list<point> intersect(ray &r);
   list<point> intersect(ray &r, point &p) {return intersect(r); }
   list<point> intersection(const line &l);
   list<point> intersection(const segment &s);
   list<point> intersection(const polygon &P);
   list<point> intersection(const circle &C);

   list<location> proj_l2sqr(const location &opt);
   
   bool operator == (const restr_ell &E);
};

#endif




