// --
// Declaration of class single_barrier_optimizer SBO (algorithm class)
// --

#ifndef SINGLE_BARRIER_OPTIMIZER_H
#define SINGLE_BARRIER_OPTIMIZER_H

//#include <math.h>
#include <LEDA/vector.h>
#include <LEDA/plane_alg.h>
#include <LEDA/array.h>
#include <LEDA/set.h>
#include <LOLA/tvec.h>
#include <LOLA/pobj.h>

class SBO {
protected:
  barrier _B;
  facilities* _EX;
  point _optimum;
  point _xlb;
  double _lb;
  double _objective;
  bool _done;
  
public:
  SBO();
  SBO(barrier,
      facilities*);
  ~SBO();
  
  double l2_sum_h1(double,
		double,
		double);

  double l2_sum_h2(double,
			  double,
			  double,
			  double);

  point optimum();
  double objective();
  double lbound();

private:
  list<segment> cpt_shdw_segs();
  list<point> cpt_start_points(const list<segment>&);
  bool hooke_jeeves_ds(const point&,
		       point&,
		       double,
		       double,
		       double,
		       set<integer>&,
		       bool);
  double D(int,int);
};
#endif
