// --
// Declaration of class tvec
// --
#ifndef CLASS_TVEC_H
#define CLASS_TVEC_H

//#include <math.h>
#include <LEDA/point.h>
#include <LEDA/integer.h>
#include <LOLA/barrier.h>
#include <LOLA/circle_barrier.h>
#include <LOLA/segment_barrier.h>
#include <LOLA/polygon_barrier.h>

class tvec {
/*********************************************************
* Purpose   : Class to store a ternary vector describing the
              algebraic structure of the objective function
* Date      : Aug 1997
* Author    : Michael Ochs
**********************************************************/ 
protected:
  int* _data;
  int  _length;
public:
  tvec();
  tvec(barrier, const facilities&, const point&);
  tvec(barrier,
       const facilities&,
       const location&);
  tvec(const tvec&);

  ~tvec();

  int* data() const;
  int  length() const;
  bool operator==(const tvec&) const;
  int flow_rank(const tvec&);
  int crash_rank(const tvec&); 
  integer number();
  friend int compare(const tvec&,const tvec&);
  friend ostream& operator<<(ostream&,tvec&);
};
#endif
