#include <LOLA/gaugealg.h>


void gaugealg::WriteOpt() {
  this->WriteOpt(cout);
}

void gaugealg::WriteOpt(ostream& out) {
  location::WriteAsPolygonList(out, solution);
}

double gaugealg::sum(list<polygauge>& LG, list<int>& Ln, facilities& EX) 
/********************************************************************
* Purpose   : Compute the optimum for 1/P/./gauge/sum
* Returns   : %
* Influences: %
* Date      : Apr 1996
* Author    : Ansgar Weissler (Update: Lothar Schnell)
*********************************************************************/
{
  double result;
  result = EX.gauge_sum(LG,Ln,true);
  solution = EX.alg_solution();
  return result;
}



double gaugealg::bi_crit_sum(list<polygauge>& LG,list<int>& Ln, facilities& EX) 
/********************************************************************
* Purpose   : Compute the optimum for 1/P/./gauge/2-sum_par
* Returns   : %
* Influences: %
* Date      : Apr 1996
* Author    : Ansgar Weissler (Update: Lothar Schnell)
*********************************************************************/
{
  double result;
  result = EX.gauge_bi_crit_sum(LG,Ln,true);
  solution = EX.alg_solution();
  return result;
}


double gaugealg::L_block_sum_M3(list<polygauge> &LG,list<int> &Ln, facilities &EX){
/********************************************************************
* Purpose   : Compute the optimum for 1L/P/./block/sum
* Returns   : %
* Influences: %
* Date      : Dec 1997
* Author    : Ingo Bartling
*********************************************************************/
	double result;
	lines LineAlg;
	result = LineAlg.L_block_sum_M3(LG,Ln,EX);
	solution = LineAlg.alg_solution();
	return result;
}

double gaugealg::L_block_max_M4(list<polygauge> &LG,list<int> &Ln, facilities &EX){
/********************************************************************
* Purpose   : Compute the optimum for 1L/P/./block/max
* Returns   : %
* Influences: %
* Date      : Dec 1997
* Author    : Ingo Bartling
*********************************************************************/
	double result;
	lines LineAlg;
	result = LineAlg.L_block_max_M4(LG,Ln,EX);
	solution = LineAlg.alg_solution();
	return result;
}


double gaugealg::L_RkonvPoly_block_sum(list<polygauge> &LG, list<int> &Ln, facilities EX, restrictions &Restr) {
/********************************************************************
* Purpose   : Compute the optimum for 1L/P/R=conv/block/sum
* Returns   : %
* Influences: %
* Date      : Feb 1998
* Author    : Ingo Bartling
*********************************************************************/
	double result;
	result = Restr.L_RkonvPoly_block_sum(LG,Ln,EX,true);
	solution = Restr.alg_solution();
	return result;
}

double gaugealg::max(list<polygauge> &LG, list<int> &Ln, facilities EX, restrictions &Restr) {
/********************************************************************
* Purpose   : Compute the optimum for 1/P/R/gauge/max
* Returns   : %
* Influences: %
* Date      : May 1999
* Author    : Ralf Leipe (Update: Holger Hennes)
*********************************************************************/
	double result;
	result = Restr.gauge_max(EX,LG,Ln,true);
	solution = Restr.alg_solution();
	return result;
}

double gaugealg::max(list<polygauge>& LG,list<int>& Ln, facilities& EX)
/********************************************************************
* Purpose   : Compute the optimum for 1/P/./gauge/max
* Returns   : %
* Influences: %
* Date      : Sep 1997
* Author    : Ralf Leipe (Update: Holger Hennes)
*********************************************************************/
{
  double result;
  result = EX.gauge_max(LG,Ln,true);
  solution = EX.alg_solution();
  return result;
}
