#include <LOLA/graph_util.h>
#include <XBitmaps/Italia_Bd.xbm>
#include <XBitmaps/Italia_Int.xbm>
#include <XBitmaps/German_Bd.xbm>
#include <XBitmaps/German_Int.xbm>


static window* Wp;
static lolagraph* Gp;
static graph_util* Gu;
static facilities* EXp;
static list<sol_typ>* Ap;
static list<bool>* W_infp;
static graph_restriction* ELp;
static bool* dirp;
static list<string>* Loctxtp;
static list<int>* pbelongto;

static void redraw_func() { Gu->draw_lolagraph(*Wp,*Gp,*Ap, *EXp, *Loctxtp, *W_infp,*ELp, *dirp); }

void graph_util::QGraphView(list<vector> objval,string normact, facilities& EX, list<string>& Loctxt, list<edge_segment>& EL, bool dir)
/********************************************************************
* Purpose   : Show optimum and objective vectors of Q-criterial network algorithms
* Returns   : %
* Influences: %
* Date      : Sep 1998 
* Author    : Karen Schulze 
*********************************************************************/
 {
  graph_util G=*this;
  string title=("LOLA VERSION 2.0   View Graphics for Q-criterial problems ");
  title+=("%s",normact);
  window W(600,650,title);
  W.set_node_width(4);
  W.set_show_coordinates(true);
  W.set_redraw(redraw_func);
  int i,pos;
  list<bool> W_inf;
  W_inf.append(false);  // Show Node Weights
  W_inf.append(false);  // Show Edge Weights
  edge_segment S;
  vector vec;
  int Q;
  if (EX.empty()) Q=G.inf(G.first_node()).size();
        else Q=EX.head().wht_dim();
  location temp(2,Q);
  facs_util EXu;
  point p,q;
  list<point> Loc, Opt, C;
  string s,tmp,txt;
  string file_name="results";

  W.buttons_per_line(3);

  i = 0;

  W.button("Save Results",1);
  //W.button("Load Results",2);
  W.button("View Results",3);
  W.button("Show Node_weights",4);
  W.button("Show Edge_weights",5);
  W.button("Refresh",8);
  W.button("Close",9);

 // Die Liste EL in echte Kantenlosungen und Knotenloesungen aufteilen:
 list<sol_typ> AlgSol;
 graph_restriction EK;
 sol_typ Atyp;
 forall(S,EL)
	if(S.source==S.target) {
		Atyp.source=S.source;
		Atyp.target=S.target;
		Atyp.alpha_s=S.alpha_s;
		AlgSol.append(Atyp);
		} else 
		EK.append(S);
  W.display(650,200);
   EXp = &EX;
  Wp = &W;
  Gp = &G;
  Loctxtp = &Loctxt;
 W_infp = &W_inf;
  ELp = &EK;
  dirp = &dir;
  Ap = &AlgSol;
  //pbelongto = &belongto;
  redraw_func();
 vector oneobj;
  for(;;)
  {

   int but = W.read_mouse(p);
    if (but == 1)
      {
        panel PSave("Save results");
        PSave.string_item("file:",file_name);
        PSave.text_item("");
        PSave.text_item("");
        PSave.buttons_per_line(2);
        int bScancel = PSave.button("cancel");
        int bSok = PSave.button("ok");
        int butS = PSave.open(780,200);
	list<vector> objvec=objval;
        if (butS == bScancel) {
          file_name = "results";
               continue;
        } else if (butS == bSok) {
         ofstream F(file_name,ios::out);
         if (! F) {
          tmp = string ("Can't open file \"%s\"!",file_name);
          W.message(tmp);
         } else {
           G.SaveGraph(F,EX,Loctxt);
           F << "begin {results}" << "\n";
           forall(S,EL) {
             if (S.source == S.target) F << "Node[" << S.source+1 << "] " << endl;
             else  F << "Edge[" << S.source+1 << "][" << S.target+1 << "] " << "(" << S.alpha_s << ", " << S.alpha_t << ")" <<  endl;
           }
           F << "end {results}" << endl;
           F << "OBJECTIVE VALUES: \n";
	   forall(S,EL) {
           	if (S.source== S.target) {
		    F << "Node[" << S.source+1 << "]: " ;
		    oneobj=objvec.pop();
		    tmp=string("( ");
		    for(i=0;i<oneobj.dim()-1;i++)
			tmp += string ("%13.3lf, ",oneobj[i]);
		    tmp += string("%13.3lf)",oneobj[oneobj.dim()-1]);
               	    F << tmp << endl;
		    objvec.pop();
			} else if (S.alpha_s != S.alpha_t) {
		    F << "Edge[" << S.source+1 << "][" << S.target+1 << "] " << "(" << S.alpha_s << ") :" ;
		    tmp=string("( ");
		    oneobj=objvec.pop();
		    for(i=0;i<oneobj.dim()-1;i++)
                        tmp += string ("%13.3lf, ",oneobj[i]);
                    tmp += string("%13.3lf) ",oneobj[oneobj.dim()-1]);
		    F << tmp << endl;	
		    F << "Edge[" << S.source+1 << "][" << S.target+1 << "] " << "(" << S.alpha_t << ") :" ;
		    tmp=string("( ");
		    oneobj=objvec.pop();
		    for(i=0;i<oneobj.dim()-1;i++)
                        tmp += string ("%13.3lf, ",oneobj[i]);
                    tmp += string("%13.3lf) ",oneobj[oneobj.dim()-1]);
		    F << tmp << endl;	
		   } // if

		} // for
         }
        }
      }
    if (but == 3)
      {
        int i=0;
        panel PResults("Results of computation");
        PResults.text_item("OPTIMUM:	OBJECTIVE VECTOR(S):");
        PResults.text_item("");
	list<vector> objvec=objval;
        forall(S,EL) { 
        if (S.source == S.target) { // Knoten
          pos = S.source;
          temp = EX.contents(EX.get_item(pos));
          txt = Loctxt.contents(Loctxt.get_item(pos));
          tmp = string ("Node [%d",pos+1)+string("] ");
          if (txt.length()>0) tmp += string ("[")+txt+string("]: ");
			else  tmp += string (":");
	  objvec.pop(); // ex. doppelt
	  oneobj=objvec.pop();
          PResults.text_item(tmp);
          PResults.text_item("");
	  tmp = string("(");
	  //tmp += string ("(%8.3lf ,%8.3lf)           ( ",temp[0],temp[1]);
	  for(i=0;i<oneobj.dim()-1;i++)
	  	tmp += string ("%8.3lf, ",oneobj[i]);
	  tmp += string ("%8.3lf) ",oneobj[oneobj.dim()-1]);
        } else if (S.alpha_s != S.alpha_t) {
		tmp = string ("Edge [%d",S.source+1)+string("][%d",S.target+1)+string("]");
		tmp +=string("  (%8.3lf, %8.3lf):",S.alpha_s,S.alpha_t);
        	PResults.text_item(tmp);
        	PResults.text_item("");
 		oneobj=objvec.pop();
		tmp = string("( ");
		for(i=0;i<oneobj.dim()-1;i++)
                	tmp += string ("%8.3lf, ",oneobj[i]);
	  	tmp += string ("%8.3lf) und (",oneobj[oneobj.dim()-1]);
		oneobj=objvec.pop();
		for(i=0;i<oneobj.dim()-1;i++)
                	tmp += string ("%8.3lf, ",oneobj[i]);
	  	tmp += string ("%8.3lf) ",oneobj[oneobj.dim()-1]);
        	} // if != 
        PResults.text_item(tmp);
        PResults.text_item("");
	} // for

	
	PResults.button("OK",10);
        PResults.display(window::max,window::min);
        int butP = 0;
        butP = PResults.read_mouse();
        if (butP == 10) PResults.close();
      }

    if (but == 4)
      {
       if (W_inf.pop()) W_inf.push(false);
       else  W_inf.push(true);
       redraw_func();
    }
    if (but == 5)
      {
       if (W_inf.Pop()) W_inf.append(false);
       else  W_inf.append(true);
       redraw_func();
    }

    if (but == 8) redraw_func();
    if (but == 9) break;
  } //for
}

void graph_util::LGraphView(double objval, list<sol_typ>& AlgSol, facilities& EX, list<string>& Loctxt)
{
  graph_restriction EL;
  list<int> bt;
  LGraphView(objval, "HELLO", AlgSol, EX, Loctxt, EL, false, bt);
  return;
}


void graph_util::LGraphView(double objval, string normact, list<sol_typ>& AlgSol, facilities& EX, list<string>& Loctxt, list<int> belongto, bool dir)
{
  graph_restriction EL;
  LGraphView(objval, normact, AlgSol, EX, Loctxt, EL, dir, belongto);
}


void graph_util::LGraphView(double objval,string normact,list<sol_typ>& AlgSol, facilities& EX, list<string>& Loctxt, graph_restriction& EL, bool dir,list<int> belongto)
/********************************************************************
* Purpose    : Show optimum and objective value for network algorithm
* Returns    : %
* Influences : %
* Date       : Oct 1996
* Author     : Lothar Schnell
* Last Update: Nov 1998 (Holger Hennes)
*********************************************************************/
{
	graph_util G=*this;
	string title=("LOLA VERSION 2.0   View Graphics    ");
	title+=("%s",normact);
	window W(600,650,title);
	W.set_node_width(4);
	W.set_show_coordinates(true);
	W.set_redraw(redraw_func);
	int i,pos;
	list<bool> W_inf;
	W_inf.append(false);	// Show Node Weights
	W_inf.append(false);  // Show Edge Weights
	sol_typ S;
	vector vec;
	int Q;
	if (EX.empty()) Q=G.inf(G.first_node()).size();
	else Q=EX.head().wht_dim();
	location temp(2,Q);
	facs_util EXu;
	point p,q;
	list<point> Loc, Opt, C;
	string s,tmp,txt;
	string file_name="results";

	W.buttons_per_line(3);

	i = 0;

	W.button("Save Results",1);
//	W.button("Load Results",2);
	W.button("View Results",3);
	W.button("Show Node_weights",4);
	W.button("Show Edge_weights",5);
	W.button("Refresh",8);
	W.button("Close",9);

	W.display(650,200);
	EXp = &EX;
	Wp = &W;
	Gp = &G;
	Loctxtp = &Loctxt;
	W_infp = &W_inf;
	ELp = &EL;
	dirp = &dir;
	Ap = &AlgSol;
	pbelongto = &belongto;
	redraw_func();

	for(;;)
	{

		int but = W.read_mouse(p);

		if (but == -1) { // mouse points into the drawing area
      		// check, if the mouse points at a Opt-node, only for N-Median
			if (!belongto.empty()) {	// N-Median 
        		redraw_func();
    			int pos=0;
      			double eps = (W.xmax()-W.xmin())/100.0; // 1/100th of window width is close enough
      			list_item it=EX.first();

      			while (it) { // Auf welchen Knoten zeigt die Maus????
        			temp=EX.contents(it);
        			q = temp.loc2point();
        			if ((fabs(p.xcoord()-q.xcoord())<=eps) &&
            			(fabs(p.ycoord()-q.ycoord())<=eps)) break;
        			it = EX.succ(it);
        			++pos; // entspricht dem Knoten
      			}
				int Arank=0;
				forall(S,AlgSol) {
    				if (S.source == S.target && S.source==pos) {
						it=EX.first();
						int no_belong,listpos=0;
						forall(no_belong,belongto) {
    						temp = EX.contents(it);
							if(no_belong==Arank && listpos!=pos) { // Knoten gehoert zu pos, pos-Selber soll blau bleiben
  								p = temp.loc2point();
								W.draw_filled_node(p,red);
  							}	// if no_belong==Arank	
			    			it = EX.succ(it);
							listpos++;
						} // forall
					} // if
					Arank++;
				} //forall
			} // belongto.empty		
		} // if (button == -1)


		if (but == 1)
		{
			panel PSave("Save results");
			PSave.string_item("file:",file_name);
			PSave.text_item("");
			PSave.text_item("");
			PSave.buttons_per_line(2);
			int bScancel = PSave.button("cancel");
			int bSok = PSave.button("ok");
			int butS = PSave.open(780,200);
			if (butS == bScancel) {
				file_name = "results";
				continue;
			} else if (butS == bSok) {
				ofstream F(file_name,ios::out);
				if (! F) {
					tmp = string ("Can't open file \"%s\"!",file_name);
					W.message(tmp);
				} else {
					G.SaveGraph(F,EX,Loctxt);

					F << "begin {results}" << endl;
					F << "begin {classification}" << endl << normact << endl;
					F << "end {classification}" << endl;
          F << "begin {objective value} " << endl;
          F << string ("%13.3lf",objval) << endl << "end {objective value}" << endl;

          F << "begin {graphpointset}" << endl;
					forall(S,AlgSol) {
						if (S.source == S.target) F << "Node [" << S.source+1 << "] " << endl;
						else if (S.alpha_s != 0) F << "Edge [" << S.source+1 << "][" << S.target+1 << "] " << S.alpha_s << endl;
					}
          F << " end{graphpointset}" << endl;
					F << "end {results}" << endl;
        }
			}
		}

/*
	if (but == 2)
		{
			panel PLoad("Load results");
			PLoad.string_item("file:",file_name);
			PLoad.text_item("");
			PLoad.text_item("");
			PLoad.buttons_per_line(2);
			int bLcancel = PLoad.button("cancel");
			int bLok = PLoad.button("ok");
			int butL = PLoad.open(780,200);
			if (butL == bLcancel)
			{ 
				file_name = "results";
				continue;
			} else if (butL == bLok)
			{
				ifstream F(file_name,ios::in);
				if (! F)
				{
					tmp = string ("Can't open file \"%s\"!",file_name);
					W.acknowledge(tmp);
				} else {
					char Z;
					W.clear();
					Loctxt.clear();
					EX.clear();
					G.clear();
					AlgSol.clear();
					G.ReadGraph(F,EX,Loctxt);
					F >> tmp;
					cout<<tmp<<endl;
					F >> tmp;
					cout<<tmp<<endl;
					act_pos = F.tellg();
					do {
						F.seekg (act_pos);
						F >> Z;
						tmp = Z;
						cout<<Z<<endl;
						if (tmp == "N") {
							F >> Z >> Z >> Z >> Z >> pos;
							S.source = pos-1;
							S.target = pos-1;
							S.alpha_s = 0;
							F >> Z;
						} else if (tmp == "E") {
							F >> Z >> Z >> Z >> Z >> pos >> Z >> Z;
							S.source = pos-1;
							F >> pos;
							S.target = pos-1;
							F >> Z >> S.alpha_s;
						} else lola_error("Wrong file format for results",2101,1);
							AlgSol.append(S);
							act_pos = F.tellg();
							F >> tmp;
					} while ((tmp != "end") && !F.eof() );
					F >> tmp >> tmp >> tmp >> objval;
					redraw_func();
				}
			}
		}
*/
    if (but == 3)
      {
        int i=0;
        panel PResults("Results of computation");
        PResults.text_item("OPTIMUM:                            OBJECTIVE VALUE:");
        PResults.text_item("");

        S = AlgSol.head();
        if (S.source == S.target) {
          pos = S.source;
          temp = EX.contents(EX.get_item(pos));
          txt = Loctxt.contents(Loctxt.get_item(pos));
          tmp = string ("Node [%d",pos+1)+string("] ");
          if (txt.length()>0) tmp += string ("[")+txt+string("] ");
          tmp += string ("(%8.3lf ,%8.3lf)           %13.3lf ",temp[0],temp[1],objval);
        } else if (S.alpha_s == 0) tmp = string ("Edge [%d",S.source+1)+string("][%d",S.target+1)+string("]");
 else if (S.alpha_s != 0) {
          tmp = string ("Node [%d",S.source+1)+string("][%d",S.target+1)+string("] %4.4lf",S.alpha_s);
          pos = S.source;
          temp = EX.contents(EX.get_item(pos));
          p = temp.loc2point();
          pos = S.target;
          temp = EX.contents(EX.get_item(pos));
          q = temp.loc2point();
          vec = (q-p)*S.alpha_s;
          p = p + vec;
          tmp += string ("(%8.3lf ,%8.3lf)      %13.3lf ",p.xcoord(),p.ycoord(),objval);
        }
        PResults.text_item(tmp);
        PResults.text_item("");

        if (AlgSol.size() > 1) {
          list_item A_it;
          for(A_it = AlgSol.succ(AlgSol.first()); A_it; A_it = AlgSol.succ(A_it)){
             S = AlgSol.contents(A_it);
             if (S.source == S.target) {
               pos = S.source;
               txt = Loctxt.contents(Loctxt.get_item(pos));
               temp = EX.contents(EX.get_item(pos));
               tmp = string ("Node [%d",pos+1)+string("] ");
               if (txt.length()>0) tmp = tmp + string ("[")+txt+string("] ");
               tmp += string ("(%8.3lf ,%8.3lf)",temp[0],temp[1]);
             } else if (S.alpha_s == 0) tmp = string ("Edge [%d",S.source+1)+string("][%d",S.target+1)+string("]");
             else if (S.alpha_s != 0) {
               tmp = string ("Edge [%d",S.source+1)+string("][%d",S.target+1)+string("] %4.2lf",S.alpha_s);
               p = temp.loc2point();
               pos = S.target;
               temp = EX.contents(EX.get_item(pos));
             q = temp.loc2point();
               vec = (q-p)*S.alpha_s;
               p = p + vec;
               tmp += string ("(%8.3lf ,%8.3lf)",p.xcoord(),p.ycoord());
             }
             PResults.text_item(tmp);
	     PResults.text_item("");
          }
        }

        PResults.text_item(string("for ") + normact);
        PResults.text_item("");

        PResults.button("OK",10);
        PResults.display(window::max,window::min);
        int butP = 0;
        butP = PResults.read_mouse();
        if (butP == 10) PResults.close();
      }

    if (but == 4)
      {
       if (W_inf.pop()) W_inf.push(false);
       else  W_inf.push(true);
       redraw_func();
    }

    if (but == 5)
      {
       if (W_inf.Pop()) W_inf.append(false);
       else  W_inf.append(true);
       redraw_func();
    }

    if (but == 8) redraw_func();
    if (but == 9) break;
  } //for
}


void graph_util::draw_lolagraph(window& W, const lolagraph& Gtmp, const list<sol_typ>& A, facilities& EX, list<string>& Loctxt, list<bool> W_inf, graph_restriction& EL, bool dir)

/********************************************************************
* Purpose   : Draws a lolagraph
* Returns   : %
* Influences: %
* Date      : Oct 1996
* Author    : Lothar Schnell
*********************************************************************/
{
  lolagraph G=Gtmp;
  int Q=G.inf(G.first_node()).length(),i=0;
  location loctmp(2,Q);
  node v,w;
  node* number2node = new node[G.number_of_nodes()+1];
  forall_nodes(v,G) number2node[i++] = v;
  color c=black;
  edge e,pe;
  double qy,qx;
	char *xbm1,*xbm2;
	bool german=false,italia=false;
	color xbm_col(255,255,50);
  point p,q;
  node pv;
  color col(0,0,255);
  sol_typ S;
  list<node> NG;
  list<node> NLG;
  vector vec;
  string s;
  GRAPH<location,double> LG;
  if (!dir) G.make_directed();

  double winmax,winminx,winminy;
  double diff_loc;
  node_weight weights;
  if (EX.empty()) {
    EX.clear();
    random_source ran(int(W.xmin()),int(W.xmax()));
    int x,y;
    forall_nodes(v,G) {
      ran >> x >> y;
      loctmp[0]=x;
      loctmp[1]=y;
      weights=G.inf(v);
      for(i=0;i<Q;i++)
        loctmp(i)=weights.pop();
      EX.append(loctmp);
      //pv=LG.new_node(loctmp);
    }
  }
  winmax = L_MAX(EX.max_direction_value(0),EX.max_direction_value(1));
  diff_loc = L_MAX(EX.diff_value(0),EX.diff_value(1));
  winminx = EX.min_direction_value(0) - (0.2 * fabs(diff_loc));
  winminy = EX.min_direction_value(1) - (0.2 * fabs(diff_loc));
  winmax += (0.25 * fabs(diff_loc));
  W.init(winminx, winmax, winminy);
  winmax += winmax-L_MIN(W.xmax(),W.ymax());
  W.init(winminx, winmax, winminy);

  if (Loctxt.head()=="Milano") {
		italia=true;
	  W.init(0,100,0);
	  xbm1 = W.create_bitmap(500,500,Italia_Int_bits);
	  W.put_bitmap(9,4,xbm1,xbm_col);
	  xbm2 = W.create_bitmap(500,500,Italia_Bd_bits);
	  W.put_bitmap(9,4,xbm2);
  }
  if (Loctxt.head()=="Kiel") {
		german=true;
	  W.init(0,100,0);
	  xbm1 = W.create_bitmap(400,500,German_Int_bits);
	  W.put_bitmap(16,5,xbm1,xbm_col);
	  xbm2 = W.create_bitmap(400,500,German_Bd_bits);
	  W.put_bitmap(16,5,xbm2);
  }


  list_item facs_it=EX.first();
  list_item txt_it=Loctxt.first();
  forall_nodes(v,G) {
    loctmp = EX.contents(facs_it);
    pv=LG.new_node(loctmp);
    NG.append(v);
    NLG.append(pv);
    p = loctmp.loc2point();
    if (!W_inf.head()) s = string ("");
    else {s=string ("");for(i=0;i<Q;i++) s += string ("%5.2lf ",loctmp(i));}
    qx = p.xcoord()-diff_loc/50.0;
    qy = p.ycoord()+diff_loc/50.0;
    q = point(qx,qy);
    W.draw_ctext(q,s,black);
    W.draw_filled_node(p,c);
    W.draw_text(p,Loctxt.contents(txt_it),black);
    facs_it = EX.succ(facs_it);
    txt_it = Loctxt.succ(txt_it);
  }
  list_item v_it;
  list_item w_it;
  forall_nodes(v,G) {
    v_it = NLG.get_item(NG.rank(v)-1);
    forall_adj_nodes(w,v) {
       w_it = NLG.get_item(NG.rank(w)-1);
       pe=LG.new_edge(NLG.contents(v_it),NLG.contents(w_it),0.0);
    }
  }
  list<double> EW;
  forall_edges(e,G) EW.append(G.inf(e));
  list_item ew_it=EW.first();
  double e_weight;
  forall_edges(pe,LG) {
    LG.assign(pe,EW[ew_it]);
    ew_it = EW.succ(ew_it);
    p = LG[LG.source(pe)].loc2point();
    q = LG[LG.target(pe)].loc2point();
    if (dir) W.draw_edge_arrow(p,q,c);
    else if (!dir) W.draw_edge(p,q,c);
    e_weight = LG.inf(pe);
    if (!W_inf.tail()) s = string ("");
    else s = string ("%5.2lf",e_weight);
    vec = (q-p)*0.5;
    p = p + vec;
    W.draw_text(p,s,black);
  }
  if (!EL.empty()) {
    edge_segment restr;
    string txt;
    point ptmp,porig,qorig;
    forall(restr,EL) {
      facs_it = EX.get_item(restr.source);
      loctmp = EX.contents(facs_it);
      p = loctmp.loc2point();
      facs_it = EX.get_item(restr.target);
      loctmp = EX.contents(facs_it);
      q = loctmp.loc2point();
 porig = p;
      qorig = q;
      v=number2node[restr.source];
      w=number2node[restr.target];
      e=G.inz_edge(v,w);
      e_weight=G.inf(e);
      vec = (q-p)*0.5;
      ptmp = p + vec;
      s = string ("");
      W.draw_text(ptmp,s,black);
      txt= string ("");
      if (restr.alpha_s > 0 || restr.alpha_t < 1.0) {
        if (restr.alpha_s > 0) {
         vec = (p-q)*restr.alpha_s;
         p = p - vec;
         loctmp = point2loc(p);
         pv=LG.new_node(loctmp);
         NLG.append(pv);
         Loctxt.append(txt);
        }
        if (restr.alpha_t < 1.0) {
         vec = (p-q)*restr.alpha_t;
         q = p - vec;
         loctmp = point2loc(q);
         pv=LG.new_node(loctmp);
         NLG.append(pv);
         Loctxt.append(txt);
        }
        W.draw_filled_node(p,green);
        W.draw_filled_node(q,green);
        if (dir) W.draw_edge_arrow(p,q,green);
        else if (!dir) W.draw_edge(p,q,green);
        if (p != porig) {
         if (!W_inf.tail()) s = string ("");
         else s = string ("%5.2lf",e_weight*restr.alpha_s);
         vec = (p-porig)*0.5;
         ptmp = porig + vec;
         W.draw_text(ptmp,s,black);
        }
        if (!W_inf.tail()) s = string ("");
        else s = string ("%5.2lf",e_weight*(restr.alpha_t-restr.alpha_s));
        vec = (q-p)*0.5;
        p = p + vec;
        W.draw_text(p,s,green);
      } else {
         if (!W_inf.tail()) s = string ("");
         else s = string ("%5.2lf",e_weight);
         if (dir) W.draw_edge_arrow(p,q,green);
         else if (!dir) W.draw_edge(p,q,green);
         vec = (q-p)*0.5;
         p = p + vec;
         W.draw_text(p,s,col);
      }
    }
  }
  int pos;
  int optnr = 1;
  forall(S,A) {
    if (S.source == S.target) {
      string txt;
      pos = S.source;
      w_it = NLG.get_item(pos);
      pv = NLG.contents(w_it);
      loctmp =  LG.inf(pv);
      p =loctmp.loc2point();
      s = "";
      W.draw_text(p,s,col);
      txt = Loctxt.contents(Loctxt.get_item(pos));
      if (txt.length()>1) s =  txt + "=Opt" + (string ("%1d",optnr));
      else s =  "Opt" + (string ("%1d",optnr));
      ++optnr;
      W.draw_filled_node(p,col);
      W.draw_text(p,s,col);
    } else if (S.alpha_s == 0) {
      pos = S.source;
      w_it = NLG.get_item(pos);
      pv = NLG.contents(w_it);
      loctmp =  LG.inf(pv);
      p =loctmp.loc2point();
      pos = S.target;
      w_it = NLG.get_item(pos);
      pv = NLG.contents(w_it);
      loctmp =  LG.inf(pv);
      q =loctmp.loc2point();
      W.draw_filled_node(p,col);
      W.draw_edge(p,q,col);
    } else if (S.alpha_s != 0) {
      pos = S.source;
      w_it = NLG.get_item(pos);
      pv = NLG.contents(w_it);
      loctmp =  LG.inf(pv);
      p =loctmp.loc2point();
      pos = S.target;
      w_it = NLG.get_item(pos);
      pv = NLG.contents(w_it);
      loctmp =  LG.inf(pv);
      q =loctmp.loc2point();
      vec = (q-p)*S.alpha_s;
      p = p + vec;
      s =  "Opt" + (string ("%1d",optnr));
      ++optnr;
      W.draw_filled_node(p,col);
      W.draw_text(p,s,col);
    }
  }
	if((italia) || (german)) { W.del_bitmap(xbm1); W.del_bitmap(xbm2); }
}

//  bisher unbenutzte(=auskommentierte) Funktionen (CreateGraph), erscheinen nicht im Header...

/*
graph_util graph_util:: CreateGraph(const string locfile, const string adjfile, facilities& EX)
*/

/*********************************************************************
* Purpose   : Creates a lolagraph with a location and an adjlist file
* Returns   : %
* Influences: %
* Date      : Oct 1996
* Author    : Lothar Schnell
*********************************************************************/
/*
{
  location loctmp;
  graph_util G;
  list<string> Loctxt;
  facs_util EXu;
  ifstream lfile (locfile,ios::in);
  EXu.ReadLoc(lfile);
  int Q=EXu.head().wht_dim();
  node_weight weights;
  int i;
  forall(loctmp,EXu) {
    weights.clear();
    for(i=0;i<Q;i++)
        weights.append(loctmp(i));
    G.new_node(weights);
    EX.append(loctmp);
  }
  ifstream afile (adjfile,ios::in);
  G.ReadAdjlist(afile,Loctxt);
  return G;
}

*/



void graph_util::SaveAdjlist(ofstream& file)
/*********************************************************************
* Purpose   : Saves the adjacent list of a lolagraph in a file
* Returns   : lolagraph
* Influences: %
* Date      : Oct 1996
* Author    : Lothar Schnell
*********************************************************************/
{
 graph_util G=*this;
 string tmp;
 int poss, post;
 node v,es,et;
 edge e;
 list<node> NL;
 if (!file) lola_error("Can't open file !",2103,1);
 else {
  tmp = "begin {adjlist} ";
  file << tmp << "\n";
  forall_nodes(v,G) NL.append(v);
  forall_edges(e,G) {
    es=G.source(e);
    et=G.target(e);
    poss=NL.rank(es);
    post=NL.rank(et);
    file << poss << " " << post << " " << G.inf(e) << endl;
  }
  tmp = "end {adjlist} ";
  file << tmp << "\n";
 }
}

void graph_util::SaveGraph(ofstream& file, facilities& EX, list<string>& Loctxt)
/*********************************************************************
* Purpose   : Saves a lolagraph file
* Returns   : lolagraph
* Influences: %
* Date      : Oct 1996
* Author    : Lothar Schnell
*********************************************************************/
{
 string tmp,txt;
 list_item pointer_to_txt=Loctxt.first();
 int dim=EX.head().dim();
 int Q=EX.head().wht_dim();
 location temp(dim,Q);

 if (!file) lola_error("Can't open file !",2104,1);
 else {
  tmp = "begin {lolagraph} ";
  file << tmp << "\n";
  tmp = "begin {location} ["+(string ("%d",dim))+","+(string ("%d",Q))+"]";
  file << tmp << "\n";
 forall(temp,EX) {
    txt=Loctxt.contents(pointer_to_txt);
    pointer_to_txt=Loctxt.succ(pointer_to_txt);
    file << temp << " " << "[" << txt << "]"<<"\n";
  }
  file << "end {location}" << "\n";
  SaveAdjlist(file);
  file << "end {lolagraph}" << "\n";
 }
}

