#include <LOLA/lgraphalg.h>

void lgraphalg::WriteOpt(ostream& out) {
   string tmp;
   sol_typ S;

   out << "begin {graphpointset}" << endl;
   forall (S,solution) {
     if (S.source == S.target) tmp = string ("Node[%d",S.source+1)+string("]");
     else if (S.alpha_s == 0) tmp = string ("Edge[%d",S.source+1)+string("][%d",S.target+1)+string("]");
     else if (S.alpha_s != 0) tmp = string ("Edge[%d",S.source+1)+string("][%d",S.target+1)+string("]%lf",S.alpha_s);
     out << tmp << endl;
   }
   out << "end {graphpointset}" << endl;
}

void lgraphalg::WriteOpt() {
  this->WriteOpt(cout);
}

double lgraphalg::inmedian(loladirected& G){
  double result;
  solution = G.inmedian(result);
  return result;
}

double lgraphalg::outmedian(loladirected& G){
  double result;
  solution = G.outmedian(result);
  return result;
}

double lgraphalg::median(loladirected& G){
  double result;
  solution = G.median('m',result);
  return result;
}

double lgraphalg::median(lolaundirected& U){
  double result;
  solution = U.median('u',result);
  return result;
}

double lgraphalg::abs_inmedian(loladirected& G){
  double result;
  solution = G.inmedian(result);
  return result;
}

double lgraphalg::abs_outmedian(loladirected& G){
  double result;
  solution = G.outmedian(result);
  return result;
}

double lgraphalg::abs_median(loladirected& G){
  double result;
  solution = G.median('m',result);
  return result;
}

double lgraphalg::abs_median(lolaundirected& U){
  double result;
  solution = U.abs_med(result);
  return result;
}

double lgraphalg::center(loladirected& G){
  double result;
  solution = G.center(result);
  return result;
}

double lgraphalg::center(lolaundirected& U){
  double result;
  solution = U.center(result);
  return result;
}

double lgraphalg::abs_center(lolaundirected& U){
  double result;
  solution = U.abs_cent(result);
  return result;
}

double lgraphalg::abs_center(loladirected& G){
  double result;
  solution = G.center(result);
  return result;
}


double lgraphalg::loc_tree_median(lolatree& U){
    double result;
    solution = U.tree_node_med(result);
    return result;
}

double lgraphalg::abs_tree_median(lolatree& U){
    double result;
    solution = U.tree_med(result);
    return result;
}

double lgraphalg::loc_tree_center(lolatree& U){
    double result;
    solution = U.tree_node_center(result);
    return result;
}

double lgraphalg::abs_tree_center(lolatree& U){
    double result;
    solution = U.tree_center(result);
    return result;
}

double lgraphalg::tree_two_center(lolatree& U){
    double result;
    solution = U.two_tree_center(result);
    return result;
}

/*double lgraphalg::median(loladirected& G, graph_restriction& EL){
  double result;
  solution = EL.median(result,G);
  return result;
}

double lgraphalg::median(lolaundirected& U, graph_restriction& EL){
  double result;
  solution = EL.median(result,U);
  return result;
}

double lgraphalg::abs_median(lolaundirected& U, graph_restriction& EL){
  double result;
  solution = EL.abs_median(result, U);
  return result;
}*/

double lgraphalg::N_median_cplex(lolaundirected& U,int n,list<int>& belongto) {
  double result;
  solution=U.N_median(n,result,belongto);
  return result;
}
double lgraphalg::N_median_partitioning(lolaundirected& U,int n,list<int>& belongto) {
  double result;
  solution=U.N_partitioning(n,result,belongto,1);
  return result;
}
double lgraphalg::N_median_exchange(lolaundirected& U,int n,list<int>& belongto) {
  double result;
  solution=U.Nmed_exchange(n,result,belongto);
  return result;
}
double lgraphalg::N_median_greedy(lolaundirected& U,int n,list<int>& belongto) {
  double result;
  solution=U.N_greedy(n,result,belongto,1);
  return result;
}
double lgraphalg::N_center_partitioning(lolaundirected& U,int n,list<int>& belongto) {
  double result;
  solution=U.N_partitioning(n,result,belongto,0);
  return result;
}
double lgraphalg::N_center_greedy(lolaundirected& U,int n,list<int>& belongto) {
  double result;
  solution=U.N_greedy(n,result,belongto,0);
  return result;
}

list<vector> lgraphalg::medPareto_bi(lolaundirected& U,list<edge_segment>& wholesol) {
  list<vector> objval;
  wholesol=U.bi_medpareto(objval);
  return objval;
}

list<vector> lgraphalg::medPareto_Q(lolaundirected& U,list<edge_segment>& wholesol) {
  list<vector> objval;
  wholesol=U.Q_medpareto(objval);
  return objval;
}
list<vector> lgraphalg::medPareto(loladirected& G,list<edge_segment>& wholesol) {
  list<vector> objval;
  wholesol=G.parlocation(objval,1,1,0);
  return objval;
}

list<vector> lgraphalg::loc_medPareto(loladirected& G,list<edge_segment>& wholesol) {
  list<vector> objval;
  wholesol=G.parlocation(objval,1,0,0);
  return objval;
}

list<vector> lgraphalg::loc_medPareto(lolaundirected& U,list<edge_segment>& wholesol) {
  list<vector> objval;
  wholesol=U.parlocation(objval,0,0,0);
  return objval;
}

list<vector> lgraphalg::loc_cenPareto(loladirected& G,list<edge_segment>& wholesol) {
  list<vector> objval;
  wholesol=G.parlocation(objval,1,0,1);
  return objval;
}

list<vector> lgraphalg::loc_cenPareto(lolaundirected& U,list<edge_segment>& wholesol) {
  list<vector> objval;
  wholesol=U.parlocation(objval,0,0,1);
  return objval;
}

list<vector> lgraphalg::cenPareto(loladirected& G,list<edge_segment>& wholesol) {
  list<vector> objval;
  wholesol=G.parlocation(objval,1,1,1);
  return objval;
}

list<vector> lgraphalg::medLexi(lolaundirected& U,list<edge_segment>& wholesol) {
  list<vector> objval;
  wholesol=U.lexlocation(objval,0,1,0);
  return objval;
}

list<vector> lgraphalg::medLexi(loladirected& G,list<edge_segment>& wholesol) {
  list<vector> objval;
  wholesol=G.lexlocation(objval,1,1,0);
  return objval;
}

list<vector> lgraphalg::loc_medLexi(loladirected& G,list<edge_segment>& wholesol) {
  list<vector> objval;
  wholesol=G.lexlocation(objval,1,0,0);
  return objval;
}

list<vector> lgraphalg::loc_medLexi(lolaundirected& U,list<edge_segment>& wholesol)  {
  list<vector> objval;
  wholesol=U.lexlocation(objval,0,0,0);
  return objval;
}

list<vector> lgraphalg::loc_cenLexi(loladirected& G,list<edge_segment>& wholesol) {
  list<vector> objval;
  wholesol=G.lexlocation(objval,1,0,1);
  return objval;
}

list<vector> lgraphalg::loc_cenLexi(lolaundirected& U,list<edge_segment>& wholesol) {
  list<vector> objval;
  wholesol=U.lexlocation(objval,0,0,1);
  return objval;
}


