#include <LOLA/loladirected.h>

loladirected::loladirected (lolagraph& G)
                : lolagraph (G) {};

list<sol_typ> loladirected::inmedian(double& objval)
/*********************************************************************
* Purpose    : Returns solutions of the 1-median problem on nodes
* Returns    : list<sol_typ>
* Influences : %
* Date       : Oct 1996
* Author     : Holger Hennes
**********************************************************************/
{
node v;
int k = number_of_nodes(),i=0,j=0;
double s;
node_weight S;
loladirected PG = *this;
array<double> w(k);
matrix M(k, k);
M = PG.shortest_path();
forall_nodes(v,PG) {
  w[i++] = PG.inf(v).head();
}
forall_nodes(v,PG) {
    s = 0;
    S.clear();
    for (i = 0; i<k; i++) s += w[i] * M(i,j);
    S.append(s);
    PG.assign(v,S);
    j++;
  }
return PG.med_nodes(objval);
}

list<sol_typ> loladirected::outmedian(double& objval)
/*********************************************************************
* Purpose    : Returns solutions of the 1-outmedian problem on nodes
* Returns    : list<sol_typ>
* Influences : %
* Date       : Oct 1996
* Author     : Holger Hennes
**********************************************************************/
{
node v;
int k = number_of_nodes(),i=0,j=0;
double s;
node_weight S;
loladirected PG = *this;
array<double> w(k);
matrix M(k, k);
M = PG.shortest_path();
forall_nodes(v,PG) {
  w[i++] = PG.inf(v).head();
}
forall_nodes(v,PG) {
    s = 0;
    S.clear();
    for (i = 0; i<k; i++) s += w[i] * M(j,i);
    S.append(s);
    PG.assign(v,S);
    j++;
  }
return PG.med_nodes(objval);
}

