#include <LOLA/lolaundirected.h>

lolaundirected::lolaundirected (lolagraph G)
		: lolagraph (G) {make_undirected();};

list<sol_typ> lolaundirected::abs_med(double& objval)
/*********************************************************************
* Purpose    : Returns the solution of the absolute 1-median  graph
* Returns    : list<sol_typ>
* Influences : %
* Date       : 10-30-96
* Author     : Holger Hennes
**********************************************************************/
{
lolaundirected U=*this;
list<sol_typ> L = U.median('u',objval);
int k = U.number_of_nodes();
matrix M(k,k);
M = U.shortest_path();
return U.edge_append(L,M,objval);
}

list<sol_typ> lolaundirected::edge_append(list<sol_typ> L,matrix M,double& objval)
/*********************************************************************
* Purpose    : Returns the solution of the absolute 1-median  graph
* Returns    : list<sol_typ>
* Influences : %
* Date       : 10-30-96
* Author     : Holger Hennes
**********************************************************************/
{
lolaundirected U=*this;
bool adjacent=false;
list<node> N;
int k = U.number_of_nodes(), i=0;
list<sol_typ> K;
node v, w,nodek;
edge e;
sol_typ S,T,Z;
if (L.size() > 1) {
  forall_nodes(v,U) N.append(v);
  list_item L1_it;
  list_item L2_it;
  for(L1_it = L.first(); L1_it; L1_it = L.succ(L1_it)){
    S = L.contents(L1_it);
    w = N.contents(N.get_item(S.source));
    for(L2_it = L.first(); L2_it; L2_it = L.succ(L2_it)){
      T = L.contents(L2_it);
      v = N.contents(N.get_item(T.source));
      adjacent=false;
      forall_adj_edges(e,v)
	if (U.target(e)==w){adjacent=true;break;}
      if (adjacent) {
	double length=U.inf(e);	 
	double sum=0;
	i=0;
        forall_nodes(nodek,U) {
          M(S.source,i) < M(T.source,i) ? sum += U.inf(nodek).head()*(0.5*length + M(S.source,i)) : sum += U.inf(nodek).head() * (0.5*length + M(T.source,i));
	  ++i;
        }
        if (sum == objval) {
          Z.source = S.source;
          Z.target = T.source;
          Z.alpha_s = 0;
          K.append(Z);
        }
      }
    }
  }
  forall(S,K) L.append(S);
}
return L;
}

