#include <LOLA/lola_error.h>

// implementation of class LOLA_ERROR
int LOLA_ERROR::count;
bool LOLA_ERROR::windowed;

LOLA_ERROR::LOLA_ERROR() {
  if (count == 0) { // initialize only once, eg. see ARM, pp20 
#ifdef WITHTCLTK
    windowed=true;
#else
    windowed=false;
#endif
  }
  count++;
}

LOLA_ERROR::~LOLA_ERROR() {
  count--;
}

void lola_error(const char* errormessage,int errorcode,int exitcode, bool windowed)
/*******************************************************************
 * Purpose   : Inform the user of an error condition and exit
 * Returns   : exit(exitcode)
 * Influences: %
 * Date      : May 97
 * Author    : H. Hennes, K. Schulze
 *********************************************************************/
{
  if (windowed && LOLA_ERROR::windowed) {
    panel ShowError("LOLA-ERROR");
    ShowError.text_item("    ");
    ShowError.text_item(errormessage);
    ShowError.text_item("    Errorcode "); 
    ShowError.text_item(string("%4i",errorcode));
    ShowError.button("OK",20);
    ShowError.display(window::max,window::min);
    int butP=0;
    do {
      butP=ShowError.read_mouse();
      exit(exitcode);
    } while (butP != 20);
  } else { // non-windowed
     cerr << "LOLA error: " << errormessage << " ErrorCode: " << errorcode << endl;
      exit(exitcode);    
  }
} // void lola_error(const char* errormessage,int errorcode,int exitcode, bool windowed)


void lola_message(const char* message,int exitcode, bool windowed)
/*******************************************************************
 * Purpose   : Bring the message to the user's attention
 * Returns   : exit(exitcode) iff exitcode != 0
 * Influences: %
 * Date      : Jul 97
 * Author    : H. Hennes, K. Schulze
 ********************************************************************/
{
  if (windowed && LOLA_ERROR::windowed) {
    panel ShowMessage("LOLA-MESSAGE");
    ShowMessage.text_item("    ");
    ShowMessage.text_item(message);
    ShowMessage.button("OK",20);
    ShowMessage.display(window::max,window::min);
    int butP=0;
    do {
      butP=ShowMessage.read_mouse();
      if (!exitcode) exit(exitcode);
      else return;
    } while (butP != 20);
  } else { // non-windowed
    cout << "LOLA message: " << message << endl;
    if (!exitcode) exit(exitcode);
    else return;
  }    
} // void lola_message(const char* message,int exitcode , bool windowed)

void lola_message(const char* message,int exitcode , int okcode , bool windowed)
/*******************************************************************
 * Purpose   : Bring the message to the user's attention
 * Returns   : exit(exitcode) iff exitcode != 0
 * Influences: %
 * Date      : Jul 97
 * Author    : H. Hennes, K. Schulze
 ********************************************************************/
{
	if (windowed && LOLA_ERROR::windowed) {
		panel ShowMessage("LOLA-MESSAGE");
		ShowMessage.text_item("    ");
		ShowMessage.text_item(message);
		ShowMessage.buttons_per_line(2);
		int bcancel = ShowMessage.button("cancel");
		int bok = ShowMessage.button("ok");
		int butS = ShowMessage.open(780,150);
		if (butS == bcancel) { 
			exit(exitcode);
		} else if (butS == bok) {
			if (!okcode) exit(okcode);
			else return;
		}
	} else { // non-windowed
		cout << "LOLA message: " << message << endl;
		if (!exitcode) exit(exitcode);
		else return;
	}    
} // void lola_message(const char* message,int exitcode ,int okcode, bool windowed)
