#include <LOLA/restr_rect.h>

/****************************************************************************
* LOLA 
*
* Implementaion of _class restr_rect
* 
* DFG-Projekt AG Hamacher
* FB Mathematik
* Universit"at Kaiserlautern
* 
****************************************************************************/

static bool x_proj(location &loc, segment &seg, point &intsec) {
   point startpnt(-L_INF, loc[1]), endpnt(L_INF, loc[1]);
   segment tmp(startpnt, endpnt);
   return seg.intersection(tmp, intsec);
}

static bool y_proj(location &loc, segment &seg, point &intsec) {
   point startpnt(loc[0], -L_INF), endpnt(loc[0], L_INF);
   segment tmp(startpnt, endpnt);
   return seg.intersection(tmp, intsec);
}

/* Constructors for class rect */

restr_rect::restr_rect()
{
  pointer_to_rect=0;
  length_of_edges=0;
}

restr_rect::restr_rect(point p,double x,double y)
{
  pointer_to_rect=new point[4];
  length_of_edges=new double[2];
  
  length_of_edges[0]=x;
  length_of_edges[1]=y;
  
  point p1(p.xcoord(),p.ycoord()+y);
  point p2(p.xcoord()+x,p.ycoord()+y);
  point p3(p.xcoord()+x,p.ycoord());
  
  pointer_to_rect[0]=p;
  pointer_to_rect[1]=p1;
  pointer_to_rect[2]=p2;
  pointer_to_rect[3]=p3;
}

restr_rect::restr_rect(point p,double x,double y,double rad)
{
  pointer_to_rect=new point[4];
  length_of_edges=new double[2];
  
  length_of_edges[0]=x;
  length_of_edges[1]=y;
  
  point p1(p.xcoord(),p.ycoord()+y);
  point p2(p.xcoord()+x,p.ycoord()+y);
  point p3(p.xcoord()+x,p.ycoord());
  
  pointer_to_rect[0]=p;
  pointer_to_rect[1]=p1.rotate(p,rad);
  pointer_to_rect[2]=p2.rotate(p,rad);
  pointer_to_rect[3]=p3.rotate(p,rad);  
}

restr_rect::restr_rect(point p1,point p2,point p3,point p4)
{
  pointer_to_rect=new point[4];
  length_of_edges=new double[2];
  
  pointer_to_rect[0]=p1;
  pointer_to_rect[1]=p2;
  pointer_to_rect[2]=p3;
  pointer_to_rect[3]=p4;
  
  length_of_edges[0]=p1.distance(p4);
  length_of_edges[1]=p1.distance(p2);
}

restr_rect::restr_rect(point p1,point p2)
{
  pointer_to_rect=new point[4];
  length_of_edges=new double[2];
  
  length_of_edges[0]=(p2.xcoord()-p1.xcoord());
  length_of_edges[1]=(p2.ycoord()-p1.ycoord());
  
  point q1(p1.xcoord(),p2.ycoord());
  point q2(p2.xcoord(),p1.ycoord());
  
  pointer_to_rect[0]=p1;
  pointer_to_rect[1]=q1;
  pointer_to_rect[2]=p2;
  pointer_to_rect[3]=q2;
}
 
/* restr_rect::restr_rect(const restr_rect& copy, double bar)
{
  register int i=0;
  
  pointer_to_rect=new point[4];
  length_of_edges=new double[2];
  
  for(i=0;i<4;i++) 
    pointer_to_rect[i]=copy.pointer_to_rect[i];
  for(i=0;i<2;i++)
    length_of_edges[i]=copy.length_of_edges[i];
  _bartyp=bar;
} */
 
restr_rect::restr_rect(const restr_rect& copy)
{
  register int i=0;
  
  pointer_to_rect=new point[4];
  length_of_edges=new double[2];
  
  for(i=0;i<4;i++) 
    pointer_to_rect[i]=copy.pointer_to_rect[i];
  for(i=0;i<2;i++)
    length_of_edges[i]=copy.length_of_edges[i];
  //  _bartyp=copy._bartyp;
}

restr_rect::~restr_rect()
{
  delete pointer_to_rect;
  delete length_of_edges;
}


double restr_rect::area()
{
  return length_of_edges[0]*length_of_edges[1];
}

bool restr_rect::inside(const location& l) {
  point p=l.loc2point();
  return inside(p);
}

bool restr_rect::inside(const point& p)
{
restr_poly RP(vertices());
return RP.inside(p);
}

bool restr_rect::inside(const segment &s) {
   if (inside(s.source()) && inside(s.target())) return true;
   return false;
}

list<point> restr_rect::vertices() {
   list<point> result;
   for (int i=0; i<4;++i) result.append(pointer_to_rect[i]);
   return result;
}

list<segment> restr_rect::segments() {
	restr_poly RP(vertices());
	return RP.segments();
}

list<point> restr_rect::intersect(point &p, point &q) {
   list<point> result;
   segment s(p,q);
   result = intersection(s);
   return result;
}

list<point> restr_rect::intersect(ray &r, point &r2) {
   point r1 = r.source();
   list<point> result = intersect(r1,r2);
   point totest = result.head();
/*
   if ( !( r.element(totest) ) ) result.pop();
   if ( (result.length > 0) && !( r.element(totest) ) ) result.pop();
*/
   return result;
}


list<point> restr_rect::intersection(const line &l) {
   list<point> result;
   list<segment> seg_list;
   seg_list.append(segment(pointer_to_rect[0], pointer_to_rect[1]));
   seg_list.append(segment(pointer_to_rect[1], pointer_to_rect[2]));
   seg_list.append(segment(pointer_to_rect[2], pointer_to_rect[3]));
   seg_list.append(segment(pointer_to_rect[3], pointer_to_rect[0]));
   segment t;
   point p;
   forall(t, seg_list) 
     if (l.intersection(t, p))
       if (result.empty()) result.append(p);
       else if (p != result.tail() ) result.append(p);
   return result;
}

list<point> restr_rect::intersection(const segment &s) {
   list<point> result;
   list<segment> seg_list;
   seg_list.append(segment(pointer_to_rect[0], pointer_to_rect[1]));
   seg_list.append(segment(pointer_to_rect[1], pointer_to_rect[2]));
   seg_list.append(segment(pointer_to_rect[2], pointer_to_rect[3]));
   seg_list.append(segment(pointer_to_rect[3], pointer_to_rect[0]));
   segment t;
   point p;
   forall(t, seg_list) 
     if (s.intersection(t, p))
       if (result.empty()) result.append(p);
       else if (p != result.tail() ) result.append(p);
   return result;
}
list<point> restr_rect::intersection(const polygon &P) {
   list<point> result;
   list<segment> seg_list;
   seg_list.append(segment(pointer_to_rect[0], pointer_to_rect[1]));
   seg_list.append(segment(pointer_to_rect[1], pointer_to_rect[2]));
   seg_list.append(segment(pointer_to_rect[2], pointer_to_rect[3]));
   seg_list.append(segment(pointer_to_rect[3], pointer_to_rect[0]));
   segment t1,t2;
   point p;
   for(list_item it = seg_list.first(); it; it = seg_list.succ(it))
   {
     t1 = seg_list.contents(it);
     forall(t2, P.segments())
       if (t2.intersection(t1, p))
         if (result.empty()) result.append(p);
         else if (p != result.tail() && p != result.head()) result.append(p);
   }
   return result;
}


list<point> restr_rect::intersection(const circle &C) {
   list<point> result;
   list<segment> seg_list;
   seg_list.append(segment(pointer_to_rect[0], pointer_to_rect[1]));
   seg_list.append(segment(pointer_to_rect[1], pointer_to_rect[2]));
   seg_list.append(segment(pointer_to_rect[2], pointer_to_rect[3]));
   seg_list.append(segment(pointer_to_rect[3], pointer_to_rect[0]));
   segment t;
   list<point> pl;
   point p;
   for(list_item it = seg_list.first(); it; it = seg_list.succ(it))
   {
     t = seg_list.contents(it);
     pl=C.intersection(t);
     if (pl.size()>0)
     forall(p, pl)
       if (result.empty()) result.append(p);
       else if (p != result.tail() && p != result.head()) result.append(p);
   }
   return result;
}

list<location> restr_rect::proj_l2sqr(const location &opt) {
   list<location> result;
   list<segment> seg_list;
   seg_list.append(segment(pointer_to_rect[0], pointer_to_rect[1]));
   seg_list.append(segment(pointer_to_rect[1], pointer_to_rect[2]));
   seg_list.append(segment(pointer_to_rect[2], pointer_to_rect[3]));
   seg_list.append(segment(pointer_to_rect[3], pointer_to_rect[0]));
   point p=opt.loc2point(),cut;
   segment t,tmp;
   line l;
   for(list_item it = seg_list.first(); it; it = seg_list.succ(it))
   {
     t = seg_list.contents(it);
     l = line(t);
     tmp = l.perpendicular(p);
     if (t.intersection(tmp,cut)) result.append(point2loc(cut));
   }
   if (!inside(opt)) {
     list<point> pl;
     pl = vertices();
     forall(p, pl) result.append(point2loc(p)); }
   return result;
}


double restr_rect::proj_v1_l2_max(location &opt, facilities &facs, double z_opt_tmp) {
/*****************************************************************************
* Purpose    : Compute the optimum for problem class 1|P|R=Polyeder|l_2|max
* Returns    : %
* Influences : %
* Date       : Oct 98
* Author     : Holger Hennes
*****************************************************************************/
   location pnt = opt;
   double epsilon = 1.0E-13;
   restriction *tmp_restrict = this;
   if (tmp_restrict->subtype() != restr_r)
     lola_error("The restriction for this algorithm must be a rectangle",1406,1);
   restr_rect *restrict = (restr_rect*)tmp_restrict;
   list<double> z_tmp;
   list<point> possible_sol;
   list<segment> edges = restrict->segments();
   for (list_item loc_tmp = facs.first(); loc_tmp; loc_tmp = facs.succ(loc_tmp)) {
      location loc = facs.contents(loc_tmp);
      for (list_item seg_tmp = edges.first(); seg_tmp; seg_tmp = edges.succ(seg_tmp)) {
	     point proj_pnt;
	     segment seg = edges.contents(seg_tmp);
	     if (x_proj(loc, seg, proj_pnt)) {
	       double dist = loc(0) * (loc - point2loc(proj_pnt)).norm(2);
	       if (dist > z_opt_tmp) {
	         z_tmp.append(dist);
	         possible_sol.append(proj_pnt);
		   }
		 }
	     if (y_proj(loc, seg, proj_pnt)) {
	       double dist = loc(0) * (loc - point2loc(proj_pnt)).norm(2);
	       if (dist > z_opt_tmp) {
	         z_tmp.append(dist);
	         possible_sol.append(proj_pnt);
		   }
		 } 
      }
   }
   for (list_item loc_tmp0 = facs.first(); loc_tmp0 != facs.last(); loc_tmp0 = facs.succ(loc_tmp0)) {
      location loc_k = facs.contents(loc_tmp0);
      for (list_item loc_tmp1 = facs.succ(loc_tmp0); loc_tmp1; loc_tmp1 = facs.succ(loc_tmp1)) {
		location loc_l = facs.contents(loc_tmp1);
		if (loc_k(0) == loc_l(0)) {
			line mid_line = mid_perpend(loc_k, loc_l);	
			list<point> intsecpnts = restrict->intersection(mid_line);
			if (intsecpnts.length() <= 2) {
				for (list_item trav = intsecpnts.first(); trav; trav = intsecpnts.succ(trav)) {
					location intsecloc = point2loc(intsecpnts.contents(trav));
					double dist = loc_l(0) * (loc_l-intsecloc).norm(2);
					if (dist > z_opt_tmp) {
						z_tmp.append(dist);
						point sol_pnt = intsecpnts.contents(trav);
						possible_sol.append(sol_pnt);
					}
				}
			}
		}
		else {
			double mu = loc_l(0)/loc_k(0);
			double c1 = (loc_k[0]-loc_l[0]*L_sqr(mu))/(1-L_sqr(mu));
			double c2 = (loc_k[1]-loc_l[1]*L_sqr(mu))/(1-L_sqr(mu));
			double c3 = (mu/fabs(1-L_sqr(mu)))*((loc_k-loc_l).norm(2));
			circle GL1(c1, c2, c3);
			list<point> intsecpnts = restrict->intersection(GL1);
			for (list_item trav = intsecpnts.first(); trav; trav = intsecpnts.succ(trav)) {
				location intsecloc = point2loc(intsecpnts.contents(trav));
				double dist = loc_l(0) * (loc_l-intsecloc).norm(2);
				double dist1 = loc_k(0) * (loc_k-intsecloc).norm(2);
				if (dist > z_opt_tmp) {
					z_tmp.append(dist);
					point sol_pnt = intsecpnts.contents(trav);
					possible_sol.append(sol_pnt);
				}
			}
		}
      }
   }
   double z = L_INF; int chk = 0;
   list_item pnt2sol = possible_sol.first();
   location final_sol = point2loc(possible_sol.head());
   for (list_item trav = z_tmp.first(); trav; trav = z_tmp.succ(trav)) {
      double z_temp = z_tmp.contents(trav);
      point sol = possible_sol.contents(pnt2sol);
      chk = 1;
	  for (list_item loc_tmp = facs.first(); loc_tmp; loc_tmp = facs.succ(loc_tmp)) {
		location loc = facs.contents(loc_tmp);
		double dist = loc(0) * (loc - point2loc(sol)).norm(2);
		if (dist - z_temp > epsilon) chk = 0;
	  }
	  if (chk && z_temp < z) {
		z = z_temp;
		final_sol = point2loc(sol);
      }
      pnt2sol = possible_sol.succ(pnt2sol);
   }
   opt = final_sol;
   return z;
}

double restr_rect::gauge_max(list<location> &opt, facilities &EX, double zmax, list<polygauge> &LG, list<int> &Ln)
/*****************************************************************************
* Purpose    : Compute the optimum for problem class 1|P|R=ConvexPolyeder|gauge|max
* Returns    : %
* Influences : %
* Date       : May 99
* Author     : Ralf Leipe (included by Holger Hennes)
*****************************************************************************/
{	
	restr_poly RP(this->vertices());
	double z=RP.gauge_max(opt,EX,zmax,LG,Ln);
	return z;
}   

point& restr_rect::operator[](int i)
{
  if ((i<0) || (i>3)) lola_error("rect: PointArg out of range.",1407,1);
  return pointer_to_rect[i];
}

double& restr_rect::operator()(int j)
{
  if ((j<0) || (j>1)) lola_error("rect: LengthArg out of range.",1408,1);
  return length_of_edges[j];
}

int restr_rect::operator==(const restr_rect& r1)
{
  register int i = 3;
  
  while ((i) && (pointer_to_rect[i]==r1.pointer_to_rect[i]))
    i--;
  return (!i);
}

restr_rect& restr_rect::operator=(const restr_rect& r1)
{
  register int i=0;
  
  delete pointer_to_rect;
  delete length_of_edges;
  
  pointer_to_rect=new point[4];
  length_of_edges=new double[2];
  
  for(i=0;i<4;i++)
    pointer_to_rect[i]=r1.pointer_to_rect[i];
  for(i=0;i<2;i++)
    length_of_edges[i]=r1.length_of_edges[i];
    
  return (*this);
}

ostream& operator<<(ostream& os, const restr_rect& r)
{
 register int i=0;
 os << "{";
 for(i=0;i<4;i++)
   os << r.pointer_to_rect[i] << ",";
 os << "|";
 for(i=0;i<2;i++)
   os << r.length_of_edges[i] << ",";
 os << "}" << endl;
 return os;
}



