%{
#include <math.h>
#if defined(LOLA_LIBSRC_GA) || defined(DEBUGLEX)
   #include <LOLA/gauge_util.h>
#endif
%}

%option noyywrap
%option c++
%option yylineno

/* Zustaende fuer ReadLPGauge*/
%x LP_Begin
%x Point
%x Fehlerzustand
%x ForceNewline
%x Comment

/* Zustaende fuer ReadLMGauge*/
%x Mix_Begin
%x Bool_flag
 
/* Variablen */
%{
  list<polygauge> resultLP; //fuer LPGauge
  list<mixgauge> resultLM; // fuer LMGauge
  list<point> result_points;
  int count=0;
  double x_coord,y_coord;
  string errmessage = "Syntaxerror in location file!";
  int errcode = 1608;
  int call_condition; // return-adress for <*>-rules
  bool linebreak_leg = false; // flag to allow the next linebreak
  string typ ="LPGauge" ; // Art des Eingelesenen Files;default ist Polygaugelist 
  list<bool> bool_tl; //fuer LMGauge
%}
ws [ \t]
DIGIT [0-9]
NODIGIT [^0-9\n\r]
INTEGER ("+"|"-")?{DIGIT}+
REAL {INTEGER}(\.{DIGIT}*)?([eE]{INTEGER})?
NOEOL [^\n\015]
ID [a-z][a-z0-9]*
BOOL [01]
%{
#undef yyFlexLexer
#define yyFlexLexer gaugeFlexLexer
#include <FlexLexer.h>
#ifdef LOLA_LIBSRC_GA

	#ifdef NO_FLEX
list<mixgauge> ReadLMGauge(ifstream& file)
/*******************************************************************
* Purpose   : Reads a list of mixgauge file
* Returns   : List of mixgauge
* Influences: %
* Date      : July 1996
* Author    : Lothar Schnell
*******************************************************************/
{
 cout << "ungeflextes LMGauge" << endl;
 long act_pos;
 string tmp;
 mixgauge M;
 list<bool> tl;
 list<point> pl;
 list<mixgauge> result;

 if (!file) lola_error("Can't open file !",1609,1);
 else {
  while ((tmp!="begin") || file.eof()) file >> tmp;
  file >> tmp;
  if (tmp!="{mixgaugelist}" && tmp!="{mixgauge}") lola_error("no mixgaugelist file in ReadLMGauge",1610,1);

  act_pos = file.tellg();
  while ((tmp != "end") && !file.eof())
  {
    file.seekg (act_pos);
    tl.clear();
    pl=ReadGauge(file,tl);
    M=mixgauge(pl,tl);
    act_pos = file.tellg();
    file >> tmp >> tmp;
    result.append(M);
  }
 }
 return result;
}
list<polygauge> ReadLPGauge(ifstream& file)
/********************************************************************
* Purpose   : Reads a list of polygauge file
* Returns   : List of polygauge
* Influences: %
* Date      : July 1996
* Author    : Lothar Schnell
*********************************************************************/
{
 cout << "ungeflextes LPGauge" << endl;
 long act_pos;
 string tmp;
 polygauge LG;
 list<polygauge> result;

 if (!file) lola_error("Can't open file !",1607,1);
 else {
  while ((tmp!="begin") || file.eof()) file >> tmp;
  file >> tmp;
  if (tmp!="{polygaugelist}" && tmp!="{polygauge}") lola_error("no polygaugelist file in ReadLPGauge",1608,1);

  act_pos = file.tellg();
  while ((tmp != "end") && !file.eof())
  {
    file.seekg (act_pos);
    LG=polygauge(ReadGauge(file));
    act_pos = file.tellg();
    file >> tmp >> tmp;
    result.append(LG);
  }
 }
 return result;
}
	#else // geflext
/******* neue ReadGauge's definieren... in gauge_util.h deklariert*******/

list<polygauge> ReadLPGauge(ifstream& file)
/********************************************************************
* Purpose   : Reads a list of polygauge file
* Returns   : List of polygauge
* Influences: %
* Date      : Mar 1998
* Author    : Karen Schulze
*********************************************************************/
{
resultLP.clear();
typ="LPgauge";
if (!file) lola_error("Can't open file!",1607,1);
else { //jetzt flexen
               FlexLexer* gaugeLP = new gaugeFlexLexer();
                int remember=2;
               while(remember > 1) remember=gaugeLP->yylex(&file);
                if (remember==1) { lola_error(errmessage,errcode,1); }
        }
return resultLP;
}
list<mixgauge> ReadLMGauge(ifstream& file)
/********************************************************************
* Purpose   : Reads a list of mixgauge file
* Returns   : List of mixgauge
* Influences: %
* Date      : Mar 98
* Author    : Karen Schulze
*********************************************************************/
{
resultLM.clear();
typ="Mixgauge";
if (!file) lola_error("Can't open file!",1609,1);
else { //jetzt flexen
               FlexLexer* gaugeLM = new gaugeFlexLexer();
                int remember=2;
               while(remember > 1) remember=gaugeLM->yylex(&file);
                if (remember==1) { lola_error(errmessage,1610,1); }
        }
return resultLM;
}

	#endif
#endif

%}

%%
        /************* A N F A N G S Z U S T A N D ************************************/
[ \n]+  /*Vor Beginn Leerzeilen zulassen */

        /* allow arbitrary whitespace */
<*>[[:blank:]\r]

"begin"[ ]*"{"[ ]*"polygaugelist"[ ]*"}"[ ]*\n               {if (typ!="LPgauge") {
								 errmessage = string("Wrong file!",lineno(),YYText());
								  BEGIN(Fehlerzustand);}
								  else
                                                             	   //cout << "Typ gefunden " << endl;
                                                             BEGIN(LP_Begin);
							     }


"begin"[ ]*"{"[ ]*"mixgaugelist"[ ]*"}"[ ]*\n               {if (typ!="Mixgauge") {
                                                                 errmessage = string("Wrong file!",lineno(),YYText());
                                                                  BEGIN(Fehlerzustand);}
                                                                  else
                                                             	  //cout << "Typ gefunden " << endl;
                                                             BEGIN(Mix_Begin);
                                                             }

"begin"[ ]*"{"[ ]*"polygauge"[ ]*"}"[ ]*\n	{
						if (typ!="LPgauge") {
                                                                 errmessage = string("Wrong file!",lineno(),YYText());
                                                                  BEGIN(Fehlerzustand);}
						 typ="oneLPGauge";
						 count=0;
						 //cout << "one gauge " << endl;
						 BEGIN(Point);}

"begin"[ ]*"{"[ ]*"mixgauge"[ ]*"}"[ ]*\n      {
						if (typ!="Mixgauge") {
                                                                 errmessage = string("Wrong file!",lineno(),YYText());
                                                                  BEGIN(Fehlerzustand);}
						 typ="oneMixGauge";
                                                 count=0;
                                                 //cout << "one gauge " << endl;
                                                 BEGIN(Point);}


<ForceNewline>\n {
  /* Wait for end-of-line but allow <*>-rules to apply. This is a dummy
  * start condition if you don't want to do anything at eol or are too
  * lazy to implement an own \n-rule for some start condition */
  BEGIN(call_condition);
}

        /************* C o m m e n t s ************************************/
        /* quick and ineffcient way to do comments - see man flex for
           alternatives */
<*>"\x2F\x2F".*  { /* (\x2F = /) not matching newline is important, so
                   the end-of-line information is retained */
  linebreak_leg = true;
}

<*>"\x2F\*" { call_condition = YY_START; BEGIN(Comment); } /* \x2F = / */
<Comment>. // this has to be just one character, so */ takes precedence
<Comment>\*\x2F { BEGIN(call_condition); } /* \x2F = / */

        /************ M I X _ B E G I N  ***************************************/
<Mix_Begin>"begin"[ ]*"{"[ ]*"mixgauge"[ ]*"}"[ ]*\n    {//cout << "begin mixgauge" << endl;
                                                        count=0;
                                                        BEGIN(Point);}


<Mix_Begin>"end"[ ]*"{"[ ]*"mixgaugelist"[ ]*"}"[ ]*    {//cout << "end mixgaugelist" << endl;
                                                        return 0; // Zurueck
                                                        }

<Mix_Begin>. {
  errmessage = string("'begin {mixgauge}' or 'end {mixgaugelist}' expected in line %d, found \"%s%%s\" instead.",lineno(),YYText());
  BEGIN(Fehlerzustand);}


	/************ L P _ B E G I N  ***************************************/
<LP_Begin>"begin"[ ]*"{"[ ]*"polygauge"[ ]*"}"[ ]*\n	{//cout << "begin polygauge" << endl;
							count=0;
							BEGIN(Point);}


<LP_Begin>"end"[ ]*"{"[ ]*"polygaugelist"[ ]*"}"[ ]* 	{//cout << "end polagaugelist" << endl;
							return 0; // Zurueck 
							}

<LP_Begin>. {
  errmessage = string("'begin {polygauge}' or 'end {polygaugelist}' expected in line %d, found \"%s%%s\" instead.",lineno(),YYText());
  BEGIN(Fehlerzustand);
}
	/************  P O I N T *****************************************/
<Point>{REAL}{ws}*	{if (count==0)
				x_coord=atof(YYText());
				else
				y_coord=atof(YYText());
			 count++;
			if (count==2)	{point temp(x_coord,y_coord);
					 result_points.append(temp);
					 //cout << "Point ist: " << temp << endl;
					 count=0;
					 if (typ=="Mixgauge") BEGIN(Bool_flag);}
			if (count>2)	 {
					errmessage = string("too many numbers in line %d",lineno());
  					BEGIN(Fehlerzustand);}
			}

<Point>"end"[ ]*"{"[ ]*"polygauge"[ ]*"}"[ ]*\n 	{//cout << "end polygauge" << endl;
						 polygauge LM=polygauge(result_points);
						 //cout << "LM ist " << LM << endl;
						 resultLP.append(LM); 
						 result_points.clear();
						 if (typ=="LPgauge") BEGIN(LP_Begin);
							else return 0;
						}


<Point>"end"[ ]*"{"[ ]*"mixgauge"[ ]*"}"[ ]*\n         {//cout << "end mixgauge" << endl;
                                                 mixgauge MG=mixgauge(result_points,bool_tl);
                                                 //cout << "MG ist " << MG << endl;
                                                 resultLM.append(MG);
                                                 result_points.clear();
                                                 if (typ=="Mixgauge") BEGIN(Mix_Begin);
                                                        else return 0;
                                                }
<Point>. {
  errmessage = string("unexpected  text in line %d",lineno());
  BEGIN(Fehlerzustand);
}

	/************* B O O L _ F L A G ********************************/
<Bool_flag>{BOOL}{ws}* 		{ bool_tl.append(atof(YYText()));
				 //cout << "gefunden: " << YYText()<< endl;
				 BEGIN(Point); 
				 }
        /************* F E H L E R Z U S T A N D  ***********************************/
<Fehlerzustand>{NOEOL}* {
//cout << "Fehler im Location-File..." << endl;
// insert rest of line in location of a %s
errmessage = string(errmessage.cstring(),YYText());
return 1;
}

<Fehlerzustand>\n { // falls der Fehler am Zeilenende war
errmessage = string(errmessage.cstring(),"");
return 1;
}

        /************ L e e r z e i l e n ***********************************/
<*>\n { // eat up otherwise unwanted newline
if (!linebreak_leg) {
	switch(YY_START) {
	case LP_Begin:
		{
		errmessage=string("Illegal linebreak in gauge-file at line %d.",lineno() - 1);
		return 1;
		}
	}
	} else { linebreak_leg = false; }
}

%%

/* Hauptprogramm, liest ein file ein, nur zum Testen, wenn nicht in LOLA eingebunden.. */
#ifdef DEBUGLEX
main(int argc, char** argv) {
  int rc;

  if (argc != 2) {
    cerr << "Please exactly one file as input.\n";
    exit(1);
  }

  ifstream file (argv[1],ios::in);

  //filename = string(argv[1]);
  FlexLexer* lexer = new gaugeFlexLexer();
  rc = lexer->yylex(&file);
  if (rc) {
    cerr << string("Error(%d): ",rc) << errmessage << endl;
    exit(1);
  } else {
	cout << " Eingelesenes Objekt:" << endl;
  	resultLM.print(" ");
  }
  return 0;
}
#endif

