%{
#include <math.h>
#if defined(LOLA_LIBSRC_PU) || defined(DEBUGLEX)
   #include <LOLA/facs_util.h>
   #include <LOLA/graph_util.h>
#endif
%}

%option noyywrap
%option c++
%option yylineno

/* Zustaende fuer ReadLoc*/

%x Dimension
%x Gewichtsdim
%x Fehlerzustand
%x Eingabe
%x Komma
%x Klammer 
%x WeightEingabe
%x Text
%x Fertig
%x ForceNewline
%x Comment

/* Zustaende fuer ReadLoc (gauge-Version) */
%x GaugeDist

/*Zustaende fuer ReadGraph*/
%x Adjlist
%x Kanteneingabe
%x Kanteneingabe_name
%x Kantengewicht
%x Kantenende
 

/* Variablen */
%{
  int Q,d,counter=0; // Q = weightdimension, d = dimension
  double number; // scratch space
  list<double> coords,weights; // accumulators for content of one line
  facs_util EX; // accumulator for content of one file
  list<string> LocTxt_flex; // accumulator for name tags
  bool txtflag=false; // whether there was a name tag already found in line
  string errormessage = "Syntaxerror in location file!";
  int errorcode = 1504;
  int calling_condition; // return-adress for <*>-rules
  bool linebreak_legal = false; // flag to allow the next linebreak
  string filename = ""; // name of the file parsed, for error messages
  string type ="Locationfile" ; // Art des Eingelesenen Files;default ist Readloc
  graph_util G; // fuer ReadGraph
  list<int> start_node,end_node;        // fuer ReadGraph, Kanten erzeugen
  list<double> edge_weight;     // fuer Readgraph, Kantengewicht
  list<int> Dist_flex;  // fuer ReadLoc (gauge-Version)
%}
ws [ \t]
DIGIT [0-9]
NODIGIT [^0-9\n\r]
INTEGER ("+"|"-")?{DIGIT}+
REAL {INTEGER}(\.{DIGIT}*)?([eE]{INTEGER})?
NOEOL [^\n\015]
ID [a-z][a-z0-9]*
%{
#ifdef LOLA_LIBSRC_PU
/******* neue Readloc's definieren... in facs_util.h deklariert*******/
void facs_util::ReadLoc(ifstream& file)
{
EX.clear();
LocTxt_flex.clear();
LocTxt.clear();
counter=0;
FlexLexer* lexer = new yyFlexLexer();
if (!file) lola_error("Can't open file!",1503,1);
else { //jetzt flexen
		int remember=2;
	       while(remember > 1) remember=lexer->yylex(&file);
		if (remember==1) { lola_error(errormessage,errorcode,1);} 
	}
*this=EX;
LocTxt=LocTxt_flex;
delete lexer;
// Write(); testet,ob EX die richtigen Standorte enthaelt
}
	#ifdef NO_FLEX   // ab hier kann man zwischen geflexten und nicht geflexten Einleseroutinenen unterscheiden 
void facs_util::ReadLoc(ifstream& file,list<int>& Dist)
{
 cout << "ungeflext" << endl;
 long act_pos;
 string tmp;
 int txtl, dim, qcrit, dist;
 char Z;

 clear();
 LocTxt.clear();
 if (!file) lola_error("Can't open file !",1503,1);
 else {
  while ((tmp != "begin") && !file.eof()) file >> tmp;

  file >> tmp;
  if (tmp!="{location}") lola_error("Can't open file !",1508,1);
  file >> Z >> dim >> Z >> qcrit >> Z;

  location temp(dim,qcrit);

  act_pos = file.tellg();
  do {
   file.seekg (act_pos);
   file >> temp;
   file >> Z;
   tmp = Z;
   if (tmp == "{") {
    file >> dist >> Z >> Z;
    Dist.append(dist);
   }
   file >> tmp;
   txtl = tmp.length();
   tmp = tmp.del(--txtl);
   act_pos = file.tellg();
   append(temp);
   LocTxt.append(tmp);
   file >> tmp;
  } while ((tmp != "end") && !file.eof());
 }
 if (size()<1) lola_error("There is less than one location",1503,1);

} // void facs_util::ReadLoc(ifstream& file,list<int>& Dist)
	#else //geflext

	
/******** ReadLoc(gauge-Version), ebenfalls aus facs_util.h **********/
void facs_util::ReadLoc(ifstream& file,list<int>& Dist)
{
EX.clear();
LocTxt_flex.clear();
LocTxt.clear();
Dist_flex.clear();
Dist.clear();
counter=0;
type="GaugeLoc";
FlexLexer* lexer = new yyFlexLexer();
if (!file) lola_error("Can't open file!",1503,1);
else { //jetzt flexen
                int remember=2;
               while(remember > 1) remember=lexer->yylex(&file);
                if (remember==1) { lola_error(errormessage,errorcode,1);} 
	}
*this=EX;
LocTxt=LocTxt_flex;
Dist=Dist_flex;
//cout << "Dist ist : " << Dist << endl;
delete lexer;
}

	#endif
	#if defined(NO_FLEX)   // ab hier kann man zwischen geflexten und nicht geflexten Einleseroutinenen unterscheiden 

graph_util& graph_util:: ReadGraph(ifstream& file, facilities& GEX, list<string>& GLoctxt)
/*********************************************************************
* Purpose   : Reads a lolagraph file, adds the nodes
* Returns   : lolagraph
* Influences: EX, Loctxt
* Date      : Oct 1996
* Author    : Lothar Schnell
*********************************************************************/
{
cout << "noflex" << endl;
GEX.clear();
 graph_util G=*this;
 long act_pos,act_pos2;
 string tmp,vtxt,wtxt;
 int txtl, dim, qcrit,i;
 node_weight weight;
 location loctmp;
 char Z;
 GLoctxt.clear();
 if (!file) lola_error("Can't open file !",2105,1);
 while ((tmp != "begin") && !file.eof()) file >> tmp;
 file >> tmp;
 if (tmp != "{lolagraph}") lola_error("Is not a lolagraph file!",2106,1);

 file >> tmp;
 if (tmp == "include") {
  file >> tmp;
  facs_util EXu;
  ifstream locfile (tmp,ios::in);
  EXu.ReadLoc(locfile);
  qcrit=EXu.head().wht_dim();
  file >> tmp;
  if (tmp != "include") lola_error("Is not a correct lolagraph file!",2107,1);
  file >> tmp;
  forall(loctmp,EXu) {
    weight.clear();
    for(i=0;i<qcrit;i++)
	weight.append(loctmp(i));
    G.new_node(weight);
    GEX.append(loctmp);
  }
  ifstream adjfile (tmp,ios::in);
  G.ReadAdjlist(adjfile,GLoctxt);
 } else if (tmp == "begin") {
  file >> tmp;
  if (tmp != "{location}") lola_error("Is not a lolagraph file!",2108,1);
  file  >> Z >> dim >> Z >> qcrit >> Z;

  location temp(dim,qcrit);

  act_pos = file.tellg();
  do {
   file.seekg (act_pos);
   act_pos2 = file.tellg();
   file >> tmp;
   if (tmp == "NC") {
	double tmpw;
	weight.clear();
	for(i=0;i<qcrit;i++) {
		file >> tmpw;
		weight.append(tmpw);}
  }else  {
     file.seekg (act_pos2);
     file >> temp;
     weight.clear();
     for(i=0;i<qcrit;i++)
	 weight.append(temp(i));
     GEX.append(temp);
   }
   G.new_node(weight);
   file >> Z >> tmp;
   txtl = tmp.length();
   tmp = tmp.del(--txtl);
   act_pos = file.tellg();
   GLoctxt.append(tmp);
   file >> tmp;
  } while ((tmp != "end") && !file.eof());
  file >> tmp;
  G.ReadAdjlist(file,GLoctxt);
  file >> tmp >> tmp;
 } else lola_error("Is not a correct lolagraph file!",2109,1);
 *this=G;
 return *this;
}



graph_util graph_util::ReadAdjlist(ifstream& file, list<string>& GLoctxt)
/*********************************************************************
* Purpose   : Reads an adjacentlist file for a lolagraph, adds the edges
* Returns   : graph_util
* Influences: %
* Date      : Oct 1996
* Author    : Lothar Schnell
*********************************************************************/
{
  graph_util G=*this;
  int i=0,v,w;
  node nv;
  bool byname;
  double weight;
  string tmp,vtxt,wtxt;
  long act_pos;

  node* A = new node[G.number_of_nodes()+1];
  forall_nodes(nv,G) A[++i] = nv;

  file >> tmp >> tmp;
  if (tmp == "{adjlist}" ) byname=false;
  else if (tmp == "{adjlist_byname}" ) byname=true;
  else lola_error("Wrong file format!",2102,1);
  act_pos = file.tellg();
  do {
   file.seekg (act_pos);
   if (!byname) file >> v >> w >> weight;
   else {
     file >> vtxt >> wtxt >> weight;
     v = 0;
     w = 0;
     while (GLoctxt[GLoctxt.get_item(v)] != vtxt) ++v;
     while (GLoctxt[GLoctxt.get_item(w)] != wtxt) ++w;
     ++v;
   ++w;
   }
   G.new_edge(A[v],A[w],weight);
   act_pos = file.tellg();
   file >> tmp;
  } while ((tmp != "end") && !file.eof());
  file >> tmp;
  *this=G;
  return *this;
}
        #else // geflext
/*******ReadGraph definieren..  in graph_util.h deklariert*********/
graph_util& graph_util::ReadGraph(ifstream& file, facilities& GEX, list<string>& GLoctxt)
{
GEX.clear();
EX.clear();
LocTxt_flex.clear();
GLoctxt.clear();
G.clear();
counter=0;
FlexLexer* lexgraph = new yyFlexLexer();
if (!file) lola_error("Can't open file!",2111,1);
else { //jetzt flexen
                int remember=2;
               while(remember > 1) remember=lexgraph->yylex(&file);
                if (remember==1) { lola_error(errormessage,2112,1);} 
        }
*this=G;
GEX=EX;
GLoctxt=LocTxt_flex;
delete lexgraph;
return *this;
}
	#endif
#endif
%}

%%
	/************* A N F A N G S Z U S T A N D ************************************/
[ \n]+  /*Vor Beginn Leerzeilen zulassen */ 

	/* allow arbitrary whitespace */
<*>[[:blank:]\r]

"begin"[ ]*"{"[ ]*"location"[ ]*"}"[ ]*"["               {//cout << "Anfang Loc" << endl;
							BEGIN(Dimension);}

"begin"[ ]*"{"[ ]*"location"[ ]*"}"[ ]* { // the previous rule is definitely longer and thus takes precedence
  //cout << "no dimension" ;
  d = 2; Q = 1; // defaults
  calling_condition=Eingabe;
  BEGIN(ForceNewline);
}

"begin"[ ]*"{"[ ]*"lolagraph"[ ]*"}"[ ]*\n               {type="Graphfile";
							//cout << "Typ gefunden " << endl;
							  }



<ForceNewline>\n {
  /* Wait for end-of-line but allow <*>-rules to apply. This is a dummy
  * start condition if you don't want to do anything at eol or are too
  * lazy to implement an own \n-rule for some start condition */
  BEGIN(calling_condition);
}

	/************* C o m m e n t s ************************************/
	/* quick and ineffcient way to do comments - see man flex for
	   alternatives */
<*>"\x2F\x2F".*  { /* (\x2F = /) not matching newline is important, so
		   the end-of-line information is retained */
  linebreak_legal = true;
}

<*>"\x2F\*" { calling_condition = YY_START; BEGIN(Comment); } /* \x2F = / */
<Comment>. // this has to be just one character, so */ takes precedence
<Comment>\*\x2F { BEGIN(calling_condition); } /* \x2F = / */

	/************* D I M E N S I O N ************************************/
<Dimension>{INTEGER} {
  d=atoi(YYText());
  if (d < 1) {
    errormessage=string("Dimension too small in location file at line %d.",lineno());
    return 1;
  } else {
    //cout << "Dimension: " << d << endl;
    BEGIN(Komma);
  }
}

<Dimension>. {
  errormessage = string("Dimension expected in location file at line %d, found \"%s%%s\" instead.",lineno(),YYText());
  BEGIN(Fehlerzustand);
}

	/************* K O M M A  ************************************/
<Komma>","        {//cout << "Komma" << endl;
  BEGIN(Gewichtsdim);}

<Komma>"]" { Q = 1; BEGIN(Klammer); }

<Komma>. {
  errormessage = string("Weight dimension expected in location file at line %d, found \"%s%%s\" instead.",lineno(),YYText());
  BEGIN(Fehlerzustand);
}

	/************* G E W I C H T S D I M  ************************************/

<Gewichtsdim>{DIGIT}+ {
  Q=atoi(YYText());
  //cout << "GewichtsDimension:   " << Q << endl;
  BEGIN(Klammer);
} 

<Gewichtsdim>. {
  errormessage = string("Weight dimension expected in location file at line %d, found \"%s%%s\" instead.",lineno(),YYText());
  BEGIN(Fehlerzustand);
}

	/************* K L A M M E R  ***********************************/

<Klammer>"]" /* ] is OK :-) */
<Klammer>\n { BEGIN(Eingabe); } /* \n is necessary */
<Klammer>. {
  errormessage = string("Closing bracket expected in location file at line %d, found \"%s%%s\" instead.",lineno(),YYText());
  BEGIN(Fehlerzustand);
}

	/************* E I N G A B E  ***********************************/
	

<Eingabe>{REAL}{ws}    { // matching whitespace here makes the scanner faster ;-)) and improves error message quality
  number=atof(YYText());
  coords.append(number);counter++;
   //cout << "Eingabe " << number << " Counter" << counter << endl;
  if (counter>=d) {counter=0;BEGIN(WeightEingabe);}
} 

<Eingabe>"end"  { //cout << "Ende erfolgreich gefunden" << endl;
		if (type=="Graphfile" || type=="NCGraphfile") {
			// Aus dem facs_util-Objekt EX die Knoten des Graphen erzeugen:
			location loctmp;
			node_weight weight;
			forall(loctmp,EX) {
				weight.clear();
				for(counter=0;counter<Q;counter++)
					weight.append(loctmp(counter));
				G.new_node(weight);}
			//cout << "bisheriger Graph" << endl;
			//G.print(" ");
			if (type=="NCGraphfile") EX.clear(); //keine Koordinaten
			BEGIN(Adjlist);
			} else   return 0; // bei Location-file ist hier Ende
		} 

<Eingabe>"NC"   {if (!(type=="Graphfile" || type=="NCGraphfile"))
			{
			errormessage=string("Coordinate #%d expected in location file at line %d, found \"%s%%s\" instead.",counter+1,lineno(),YYText());
			BEGIN(Fehlerzustand);
			}
	       type="NCGraphfile";
	       counter=0;BEGIN(WeightEingabe);
		}


<Eingabe>. {
	    errormessage=string("Coordinate #%d expected in location file at line %d, found \"%s%%s\" instead.",counter+1,lineno(),YYText());
	    BEGIN(Fehlerzustand);
}

	/************* W E I G H T E I N G A B E  ***********************************/

<WeightEingabe>{REAL}/[ \]\t\n\r/]    {
  number=atof(YYText());counter++;
  weights.append(number);
  //cout << "GewichtsEingabe " << number << " Counter" << counter << endl;
  if (counter>=Q && type!="GaugeLoc") BEGIN(Text);
  if (counter>=Q && type=="GaugeLoc") BEGIN(GaugeDist);
}

<WeightEingabe>"L_INF"/[ \]\t\n\r/]    {
  number=L_INF;counter++;
  weights.append(number);
  //cout << "GewichtsEingabe " << number << " Counter" << counter << endl;
  if (counter>=Q && type!="GaugeLoc") BEGIN(Text);
  if (counter>=Q && type=="GaugeLoc") BEGIN(GaugeDist);
}


<WeightEingabe>. {
  errormessage=string("Weight #%d expected in location file at line %d, found \"%s%%s\" instead",counter+1,lineno(),YYText());
  BEGIN(Fehlerzustand);
  }

	/************ G A U G E D I S T **************************/
<GaugeDist>"["  {// ups, doch gleich Text
		 unput('[');BEGIN(Text);}

<GaugeDist>"{"{ws}*{INTEGER}{ws}*"}"    {string txp=YYText();
			int textlength=txp.length();
			txp=txp.del(--textlength);
			txp=txp.del(0);
			int gauge=atoi(txp);
			 Dist_flex.append(gauge);
			 //cout << "gefunden: " << gauge << endl; 
			BEGIN(Text);}

<GaugeDist>. {
	errormessage=string("Number of Gauge expected  at line %d, found \"%s%%s\" instead.",lineno(),YYText());                  
	BEGIN(Fehlerzustand);
	}


	/************* T E X T   ***********************************/
<Text>"["[^\r\n\]]*"]"          {
	if (!txtflag) {
		string txp=YYText();
		int textlength=txp.length();
		txp = txp.del(--textlength);
		txp = txp.del(0);
		LocTxt_flex.append(txp);
		txtflag=true;
		// cout << "Text angehaengt " << endl;
		} else {
		errormessage=string("Second name (\"%s\") found in location file at line %d.",YYText(),lineno());
		return(1);
		}
	}

<Text>\n {
//cout << "Objekt facilities erzeugen..." << endl;
location temp(d,Q);
int i=0; 

forall(number,coords) temp[i++]=number;
i=0;
forall(number,weights) temp(i++)=number; 
EX.append(temp); 
coords.clear();
weights.clear();
if (!txtflag) LocTxt_flex.append(""); // empty name
txtflag=false;
counter=0;
BEGIN(Eingabe);
}

<Text>. {
	if (txtflag) {
		errormessage=string("End of line expected in location file at line %d, found \"%s%%s\" instead.",lineno(),YYText());              
		} else {
		errormessage=string("Name of location expected in location file at line %d, found \"%s%%s\" instead.",lineno(),YYText());
		}
	BEGIN(Fehlerzustand);
	}

	/************* F E H L E R Z U S T A N D  ***********************************/
<Fehlerzustand>{NOEOL}* {
//cout << "Fehler im Location-File..." << endl;
// insert rest of line in location of a %s
errormessage = string(errormessage.cstring(),YYText());
return 1;
}

<Fehlerzustand>\n { // falls der Fehler am Zeilenende war
errormessage = string(errormessage.cstring(),"");
return 1;
}

	/************ L e e r z e i l e n ***********************************/
<*>\n { // eat up otherwise unwanted newline
if (!linebreak_legal) {
switch(YY_START) {
case Eingabe:
case Dimension:
case WeightEingabe:
case Gewichtsdim:
case Kanteneingabe:
case Kanteneingabe_name:
case Kantenende:
case Komma:
{
errormessage=string("Illegal linebreak in location file at line %d.",lineno() - 1);
return 1;
}
}
} else { linebreak_legal = false; }
}

	/************** A D J L I S T ****************/
<Adjlist>[  ]*"{"[ ]*"location"[ ]*"}"\n                

<Adjlist>"begin"[ ]*"{"[ ]*"adjlist"[ ]*"}"[ ]*\n               {
counter=0;
start_node.clear();
end_node.clear();
BEGIN(Kanteneingabe);
}

<Adjlist>"begin"[ ]*"{"[ ]*"adjlist_byname"[ ]*"}"[ ]*\n               {
counter=0;
start_node.clear();
end_node.clear();
type="byname";
BEGIN(Kanteneingabe_name);
}

<Adjlist>. {
	errormessage=string("'begin {adjlist}' expected in line %d",lineno(),YYText());
	BEGIN(Fehlerzustand);
	}

	/************** K A N T E N E I N G A B E ***********/

<Kanteneingabe>{INTEGER}{ws}   {
	int Kante=atoi(YYText());
	//cout << "Eingabe " << Kante << " Counter" << counter+1 << endl;
	counter++;
	if (counter==1) start_node.append(Kante);
	if (counter==2) {end_node.append(Kante);BEGIN(Kantengewicht);}
	}
	

<Kanteneingabe>"end"  {BEGIN(Kantenende);} 

<Kanteneingabe>. {
		errormessage=string("unexpected text  in line %d: %s",lineno(),YYText());
		BEGIN(Fehlerzustand);
		}

	/************** K A N T E N E I N G A B E _ N A M E  ***********/
<Kanteneingabe_name>"end"  {BEGIN(Kantenende);} 
<Kanteneingabe_name>{ID}        { string Suchobjekt=YYText();
			  //cout << "gefunden .. " << Suchobjekt << endl;
			  int Kante=LocTxt_flex.rank(Suchobjekt);
			  if (Kante==0) { errormessage=string("unexpected text '%s' in line %d",Suchobjekt,lineno());
					BEGIN(Fehlerzustand);}
			  counter++;
			  if (counter==1) start_node.append(Kante);
			  if (counter==2) {end_node.append(Kante);BEGIN(Kantengewicht);}
			 }
 

	/************** K A N T E N G E W I C H T ***********/


<Kantengewicht>{REAL}{ws}*\n    { // Gewicht
	double Gewicht=atof(YYText());
	//cout << "Gewicht" << Gewicht << endl;
	edge_weight.append(Gewicht);
	counter=0;
	if (type=="byname" ) BEGIN(Kanteneingabe_name);
			     else BEGIN(Kanteneingabe);
	}

<Kantengewicht>.         {errormessage=string("unexpected text  in line %d : %s",lineno(),YYText());
		BEGIN(Fehlerzustand);
		}

	/************** K A N T E N E N D E ***********/
<Kantenende>.   {
	//cout << "Ende Adjlist erfolgreich gefunden" << endl;
	// Array der Knoten mit Zahl verbindet
	node v;
	counter=0;
	node* number2node =new node[G.number_of_nodes()+1];
	forall_nodes(v,G) number2node[++counter] =v;
	// Kanten im Graphen erzeugen
	forall(counter,start_node) 
		G.new_edge(number2node[counter],number2node[end_node.pop()],edge_weight.pop());
	//cout << "Der endgueltige Graph" << endl;
	//G.print(" ");
	return 0;}
%% 

/* Hauptprogramm, liest ein file ein, nur zum Testen, wenn nicht in LOLA eingebunden.. */
#ifdef DEBUGLEX
main(int argc, char** argv) {
  int rc;

  if (argc != 2) {
    cerr << "Please exactly one file as input.\n";
    exit(1);
  }

  ifstream file (argv[1],ios::in);

  filename = string(argv[1]);
  FlexLexer* lexer = new yyFlexLexer();
  rc = lexer->yylex(&file);
  type="GaugeLoc";
  if (rc) { 
    cerr << string("Error(%d): ",rc) << errormessage << endl;
    exit(1);
  } else {
    //cout << " Eingelesenes Objekt:" << endl;
    Dist_flex.print("");
    //EX.LocTxt = LocTxt_flex; // declare facilities::LocTxt as public for this
  }
  return 0;
}
#endif

//Local Variables:
//mode: c++
//End:

