# jedit_menus.tcl - menus for jedit, a tk-based editor

######################################################################
# jedit:mkmenus - create menubar
######################################################################
######################################################################
# INITIALISATION ON AUTOLOAD:

j:ldb:set_defaults {
  {JEmenu:file {File} 0}
  {JEmenu:edit {Edit} 0}
}
jedit:register_commands


proc jedit:mkmenus {mb t} {
  j:debug
  global JEDIT_MODEPREFS
  
  set mode [jedit:get_mode $t]
  
  set all_menus {file edit}
  set displayed_menus {}
  
  foreach menu $all_menus {
    if [winfo exists $mb.$menu] {
      destroy $mb.$menu
    }
    if $JEDIT_MODEPREFS($mode,menu,$menu) {
      jedit:mkmenu:$menu $mb.$menu $t
      catch {
        pack $mb.$menu -in $mb -side left
        lappend displayed_menus $mb.$menu
      }
    }
  }
  
  # check for user menu proc - normally in ~/.tk/jeditrc.tcl
  #
  if $JEDIT_MODEPREFS($mode,menu,user) {
    if {[info procs jedit:mkmenu:user] != {}} {
      if [winfo exists $mb.user] {
        destroy $mb.user
      }
      jedit:mkmenu:user $mb.user $t
      pack $mb.user -in $mb -side left
      lappend displayed_menus $mb.user
    }
  }
  
  eval tk_menuBar $mb $displayed_menus
}


proc jedit:mkmenu:file {menu t} {
  global JEDIT_MODEPREFS
  
  j:menu:menubutton $menu $menu.m JEmenu:file
  
  j:menu:commands $menu.m $t {
    jedit:cmd:load
    jedit:cmd:save
    jedit:cmd:saveas
    jedit:cmd:print
    -
    jedit:cmd:insfile
    -
    jedit:cmd:quit
  }
}

proc jedit:mkmenu:edit {menu t} {
  global JEDIT_MODEPREFS
  
  j:menu:menubutton $menu $menu.m JEmenu:edit
  
  j:menu:commands $menu.m $t {
    jedit:cmd:cut
    jedit:cmd:copy
    jedit:cmd:paste
    jedit:cmd:select_all
    -
    jedit:cmd:find
    jedit:cmd:find_again
    -
    jedit:cmd:go_to_line
    jedit:cmd:current_line
  }
  # the last three SHOULD BE affected by later configuration, and a trace
  # on JEDIT_PREFS(undolevel) (but aren't)
}

